BorderedMorph subclass: #ArgumentPlaceHolderMorph
	instanceVariableNames: 'labelFragment isRaised '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Scratch-BYOB'!

!ArgumentPlaceHolderMorph methodsFor: 'as yet unclassified' stamp: 'jens 1/13/2010 00:06'!
acceptDroppingMorph: aBlockMorph event: evt
	"This message is sent when a morph is dropped onto a morph that has agreed to accept the dropped morph by responding 'true' to the wantsDroppedMorph:Event: message. This default implementation just adds the given morph to the receiver."

	labelFragment
		label: aBlockMorph variable;
		isInput: true.
	aBlockMorph delete.
	self template updateSpecWithDnDSpec! !

!ArgumentPlaceHolderMorph methodsFor: 'as yet unclassified' stamp: 'jens 1/21/2010 19:35'!
appear

	self
		isHidden: false;
		appearInactive! !

!ArgumentPlaceHolderMorph methodsFor: 'as yet unclassified' stamp: 'jens 12/4/2009 00:44'!
appearActiveFor: aMorph
	self
		extent: aMorph extent + (4@4);
		borderWidth: 4;
		borderColor: Color white;
		color: Color white darker! !

!ArgumentPlaceHolderMorph methodsFor: 'as yet unclassified' stamp: 'jens 1/24/2010 23:18'!
appearInactive
	self
		extent: self class dimensions;
		borderWidth: 0;
		color: Color transparent
	! !

!ArgumentPlaceHolderMorph methodsFor: 'as yet unclassified' stamp: 'jens 1/21/2010 22:46'!
drawEmbeddedOn: aCanvas
	
	| form |
	form _ (ScratchFrameMorph skinAt: #addItem) deepCopy.
	form replaceColor: (form colorAt: 5@5) with: (ScriptableScratchMorph blockColorFor: 'variables') darker.
	form replaceColor: (form colorAt: form center) with: Color white.
	super drawOn: aCanvas.
	aCanvas translucentImage: (form withEmbeddedOutlineColor: owner color width: 1) 
			at: self position + (( self extent - form extent) // 2)
! !

!ArgumentPlaceHolderMorph methodsFor: 'as yet unclassified' stamp: 'jens 1/21/2010 22:49'!
drawOn: aCanvas
	
	isRaised
		ifTrue: [self drawRaisedOn: aCanvas]
		ifFalse: [self drawEmbeddedOn: aCanvas]! !

!ArgumentPlaceHolderMorph methodsFor: 'as yet unclassified' stamp: 'jens 1/21/2010 22:57'!
drawRaisedOn: aCanvas
	
	| form |
	form _ (ScratchFrameMorph skinAt: #addItem) deepCopy.
	form replaceColor: (form colorAt: 5@5) with: (ScriptableScratchMorph blockColorFor: 'variables').
	form replaceColor: (form colorAt: form center) with: Color white.
	super drawOn: aCanvas.
	aCanvas translucentImage: (form withEmbeddedOutlineColor: owner color width: 1) 
			at: self position + (( self extent - form extent) // 2)
! !

!ArgumentPlaceHolderMorph methodsFor: 'as yet unclassified' stamp: 'jens 1/11/2010 23:28'!
handlesMouseDown: evt
	"Return true if this morph wants to receive mouseDown events (i.e., mouseDown:, mouseMove:, mouseUp:). The default response is false; subclasses that implement mouse messages should override this to return true." 

	^ true
! !

!ArgumentPlaceHolderMorph methodsFor: 'as yet unclassified' stamp: 'jens 1/21/2010 22:50'!
handlesMouseOver: evt
	"Return true if I want to receive mouseEnterDragging: and mouseLeaveDragging: when the hand drags something over me (button up or button down), or when the mouse button is down but there is no mouseDown recipient. The default response is false; subclasses that implement mouse mouseEnterDragging messages should override this to return true."

	"NOTE:  If the hand state matters in these cases, it may be tested by constructs such as
		event anyButtonPressed
		event hand hasSubmorphs"

	^ true
! !

!ArgumentPlaceHolderMorph methodsFor: 'as yet unclassified' stamp: 'jens 12/3/2009 22:05'!
handlesMouseOverDragging: evt
	"Return true if I want to receive mouseEnterDragging: and mouseLeaveDragging: when the hand drags something over me (button up or button down), or when the mouse button is down but there is no mouseDown recipient. The default response is false; subclasses that implement mouse mouseEnterDragging messages should override this to return true."

	"NOTE:  If the hand state matters in these cases, it may be tested by constructs such as
		event anyButtonPressed
		event hand hasSubmorphs"

	^ true
! !

!ArgumentPlaceHolderMorph methodsFor: 'as yet unclassified' stamp: 'jens 1/21/2010 22:48'!
initialize
	super initialize.
	isRaised _ false.
	labelFragment _ BlockLabelFragment new.
	self
		useRoundedCorners;
		appearInactive;
		updateFragment
! !

!ArgumentPlaceHolderMorph methodsFor: 'as yet unclassified' stamp: 'jens 1/12/2010 02:15'!
labelFragment
	^labelFragment! !

!ArgumentPlaceHolderMorph methodsFor: 'as yet unclassified' stamp: 'jens 1/12/2010 20:31'!
labelFragment: aBlockLabelFragmen
	labelFragment _ aBlockLabelFragmen! !

!ArgumentPlaceHolderMorph methodsFor: 'as yet unclassified' stamp: 'jens 9/2/2010 00:00'!
mouseDown: evt
	"Handle a mouse down event"

	| old frag |
	owner isFrozen 
		ifTrue: [^ self]
		ifFalse: [owner isFrozen: true].

	old _ labelFragment deepCopy.
	frag _ BlockLabelFragmentDialog on: labelFragment category: owner category.
 	owner
		isFrozen: false;
		hideArgumentPlaceHolders.
	frag = #cancelled ifTrue: [
		labelFragment _ old.
		^ self]. 
	owner updateSpecWithDnDSpec! !

!ArgumentPlaceHolderMorph methodsFor: 'as yet unclassified' stamp: 'jens 1/21/2010 23:10'!
mouseEnter: evt

	owner isFrozen 
		ifTrue: [^ self].
	isRaised _ true.
	self changed
! !

!ArgumentPlaceHolderMorph methodsFor: 'as yet unclassified' stamp: 'jens 1/21/2010 23:10'!
mouseEnterDragging: evt
	"Handle a mouseEnterDragging event. The mouse just entered my bounds with a button pressed or laden with submorphs. This default implementation does nothing."

	| m |
	owner isFrozen 
		ifTrue: [^ self].
	evt hand hasSubmorphs ifFalse: [^self].
	m _ evt hand submorphs first.
	(self wantsDroppedMorph: m event: evt)
		ifTrue: [
			self appearActiveFor: m ].
! !

!ArgumentPlaceHolderMorph methodsFor: 'as yet unclassified' stamp: 'jens 5/10/2010 00:56'!
mouseLeave: evt

	owner ifNil: [^ self].
	owner isFrozen 
		ifTrue: [^ self].
	isRaised _ false.
	self changed
! !

!ArgumentPlaceHolderMorph methodsFor: 'as yet unclassified' stamp: 'jens 1/21/2010 23:47'!
mouseLeaveDragging: evt
	"Handle a mouseLeaveLaden event. The mouse just left my bounds with a button pressed or laden with submorphs. This default implementation does nothing."

	owner ifNil: [^ self].
	owner isFrozen 
		ifTrue: [^ self].
	self appearInactive! !

!ArgumentPlaceHolderMorph methodsFor: 'as yet unclassified' stamp: 'jens 1/13/2010 00:05'!
template

	| template |
	template _ self ownerThatIsA: CustomCommandBlockMorph.
	template ifNil: [
		template _ self ownerThatIsA: CustomReporterBlockMorph].
	^ template 
! !

!ArgumentPlaceHolderMorph methodsFor: 'as yet unclassified' stamp: 'jens 1/12/2010 20:31'!
updateFragment

	labelFragment
		isInput: true;
		label: ''! !

!ArgumentPlaceHolderMorph methodsFor: 'as yet unclassified' stamp: 'jens 1/21/2010 19:34'!
vanish

	self
		isHidden: true;
		extent: 0@0! !

!ArgumentPlaceHolderMorph methodsFor: 'as yet unclassified' stamp: 'jens 1/13/2010 00:05'!
wantsDroppedMorph: aMorph event: evt
	"Return true if the receiver wishes to accept the given morph, which is being dropped by a hand in response to the given event. The default implementation returns false.
NOTE: the event is assumed to be in global (world) coordinates."

	| template |
	template _ self template.
	template ifNil: [^ false].

	^((aMorph isKindOf: VariableBlockMorph) and: [aMorph isSpecialForm]) and: [
		(template parameterNames includes: aMorph variable) not]! !

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

ArgumentPlaceHolderMorph class
	instanceVariableNames: ''!

!ArgumentPlaceHolderMorph class methodsFor: 'as yet unclassified' stamp: 'jens 1/24/2010 23:18'!
dimensions
	^ 16@10! !
