NXTPeripheral subclass: #NXTDCMotor
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Enchanting-NXT Peripherals'!
!NXTDCMotor commentStamp: '<historical>' prior: 0!
A Direct Current Motor, used to control RCX motors, train motors, or other ~9V DC (lego) motors.!


!NXTDCMotor methodsFor: 'accessing' stamp: 'CWB 5/23/2011 22:31'!
portName
"Returns the name of the port this sensor is on.  Should be either Motor.A, Motor.B, or Motor.C"

	^ 'MotorPort.', ($A asciiValue -1 + portIndex) asCharacter asString! !

!NXTDCMotor methodsFor: 'accessing' stamp: 'CWB 12/20/2010 06:37'!
variableName
"The lejos variable that references this sensor."

	^ 'M', ($A asciiValue -1 + portIndex) asCharacter asString! !


!NXTDCMotor methodsFor: 'exporting' stamp: 'LGG 5/25/2011 12:13'!
emitInitializationCodeOn: aStream for: anExporter
"Outputs the code to initialize NXT peripherals."

"Output should look something like:
public static final Motor RIGHT_MOTOR = Motor.A;"

	| motorClassName  |

	motorClassName _ anExporter codeSpecFrom: concreteType asString.

	anExporter indentOn: aStream.
	aStream nextPutAll: 'public static final ', 
		motorClassName, ' ', self variableName, ' = new ',
		motorClassName, '(', self portName, ')', ';'; cr.! !

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

NXTDCMotor class
	instanceVariableNames: ''!

!NXTDCMotor class methodsFor: 'accessing' stamp: 'CWB 12/18/2010 12:17'!
baseName

	^ 'RCX motor'! !

!NXTDCMotor class methodsFor: 'accessing' stamp: 'CWB 12/18/2010 11:03'!
concreteTypes
"Returns a list of physical devices that implement the functions of this class."

	^ #(
		'RCX Motor'
		'NXT Motor'
	).! !


!NXTDCMotor class methodsFor: 'block specs' stamp: 'CWB 12/18/2010 16:09'!
configBlockSpec

	^ 'Drives a direct current motor--a %p--named %s'.! !

!NXTDCMotor class methodsFor: 'block specs' stamp: 'CWB 7/18/2012 12:25'!
providesBlocks
"Returns a list of block specifications to be used in the main user interface if there is any device configured that can use these blocks.  Note that the 'selectors' are all unique, start with the class name followed by a colon, but do not actually have functions that go with them."

	^ #(
		'motors'
			('start turning %P %J'			-	NXTDCMotor:turnMotorDirection)
			('stop %P by %K'				-	NXTDCMotor:stopMotor)
			('%P is moving?'				b	NXTDCMotor:isMoving)
		).
! !


!NXTDCMotor class methodsFor: 'dropdown lists' stamp: 'CWB 12/17/2010 21:51'!
customListNumber: aNumber
"Peripherals can return custom lists (or nil)."

	(aNumber = 1) ifTrue: [
		"A direction to turn the motor."
		^ #('forward' 'backward')	
	].
	(aNumber = 2) ifTrue: [
		"Ways the motor can stop."
		^ #('braking' 'coasting')	
	].

	^ nil.! !
