DialogBoxMorph subclass: #ElementsEditorFrameMorph
	instanceVariableNames: 'editor initialClass initialMethod resizeMorph resizeOffset '
	classVariableNames: 'UserPos UserSize '
	poolDictionaries: ''
	category: 'Scratch-BYOB'!

!ElementsEditorFrameMorph methodsFor: 'as yet unclassified' stamp: 'jens 8/24/2009 00:07'!
centerOnScreen
	super centerOnScreen.
	self updateResizeMorph! !

!ElementsEditorFrameMorph methodsFor: 'as yet unclassified' stamp: 'jens 8/24/2009 00:07'!
definition: aCustomBlockDefinition

	definition _ aCustomBlockDefinition.
	template _ CustomCommandBlockMorph template.
	template receiver: receiver.
	template userSpec: definition userSpec.
	bin addMorph:(template position: bin position + (10@10)).
	self buildScript.
	self buildVariables.
	self buildAtomicityToggle.
	self buildAnswerField.! !

!ElementsEditorFrameMorph methodsFor: 'as yet unclassified' stamp: 'jens 12/14/2009 03:09'!
extent: aPoint
	
	| w newExtent min|

	min _ self class minExtent.

	newExtent _ aPoint max: min.

	bounds extent = newExtent ifFalse: [
		self changed.
		bounds _ bounds topLeft extent: newExtent.
		self layoutChanged.
		self changed].

	self fixLayoutForExtent: newExtent.

	UserPos isNil & resizeOffset isNil ifTrue: [
		w _ self world.
		w ifNotNil: [self position: w center - (self extent // 2)]].  "center on screen"

	self keepOnScreen
! !

!ElementsEditorFrameMorph methodsFor: 'as yet unclassified' stamp: 'jens 8/24/2009 00:58'!
fixLayoutForExtent: aPoint

	super fixLayoutForExtent: aPoint.

	titleBin ifNotNil: [ titleBin width: aPoint x - 40 ].

	editor ifNil: [^self ].

	editor extent: aPoint - (65 @ 105).

	self updateResizeMorph! !

!ElementsEditorFrameMorph methodsFor: 'as yet unclassified' stamp: 'jens 8/24/2009 00:42'!
getUserResponse
	"Wait for the user to respond, then report their response. The symbol #cancel is returned if the user wishes to cancel the operation. True/false is returned if they respond yes/no, and a string is returned if this this a string input dialog and they don't cancel."
	"Details: This is invoked synchronously from the caller. In order to keep processing inputs and updating the screen while waiting for the user to respond, this method has its own version of the World's event loop."

	| w |
	self openInWorld.

	editor onMethod: initialMethod ofClass: initialClass.

	UserPos isNil 
		ifTrue: [ self centerOnScreen ]
		ifFalse: [self snapToUserDimensions ].
		
	w _ self world.
	self buttons size > 0 ifTrue: [
		w activeHand newKeyboardFocus: self buttons last].
	tabFields size > 0 ifTrue: [
		w activeHand newKeyboardFocus: (tabFields at: 1)].

	done _ false.
	[done] whileFalse: [w doOneCycle].  "wait for user to press a button"

	^ response
! !

!ElementsEditorFrameMorph methodsFor: 'as yet unclassified' stamp: 'jens 8/24/2009 00:07'!
handlesMouseDown: evt
	^true! !

!ElementsEditorFrameMorph methodsFor: 'as yet unclassified' stamp: 'jens 8/24/2009 00:16'!
initialize
	super initialize.
	self title: 'Elements Editor'.
	resizeMorph _ ScratchResizeMorph ofType: #corner.
	
	editor := ElementsMethodEditorMorph new.

	mainColumn addMorph: editor.

	self addMorph: resizeMorph.


! !

!ElementsEditorFrameMorph methodsFor: 'as yet unclassified' stamp: 'jens 8/24/2009 00:07'!
justDroppedInto: aMorph event: evt
	"Never embed myself in a morph (e.g. the Stage)."

	super justDroppedInto: aMorph event: evt.
	self keepOnScreen
! !

!ElementsEditorFrameMorph methodsFor: 'as yet unclassified' stamp: 'jens 8/24/2009 00:07'!
keepOnScreen

	| min |
	min _ self class minExtent.

	self left < 0 ifTrue: [ self left: 0].
	self top < 0 ifTrue: [ self top: 0].

	self right > Display extent x
		ifTrue: [ resizeOffset 
			ifNil: [ 
				self left: ((Display extent x - self width) max: 0).
				(self right > Display extent x and: [self width > min x])
					ifTrue: [self width: Display extent x - self left ]]
			ifNotNil: [self width: Display extent x - self left]].

	self bottom > Display extent y
		ifTrue: [ resizeOffset 
			ifNil: [	
				self top: ((Display extent y - self height) max: 0). 
				(self bottom > Display extent y and: [self height > min y])
					ifTrue: [self height: Display extent y - self top]]
			ifNotNil: [self height: Display extent y - self top]].

! !

!ElementsEditorFrameMorph methodsFor: 'as yet unclassified' stamp: 'jens 8/24/2009 00:07'!
mouseDown: evt
	"Handle a mouse click. Left button either drags or performs click action. Right button brings up a menu."

	| p |
	p _ evt cursorPoint.
	((resizeMorph bounds expandBy: 4) containsPoint: p)
		ifFalse: [evt hand grabMorph: self]
		ifTrue: [resizeOffset _ self bottomRight - p]
! !

!ElementsEditorFrameMorph methodsFor: 'as yet unclassified' stamp: 'jens 8/24/2009 00:07'!
mouseMove: evt

	resizeOffset ifNotNil: [
		self extent: (evt cursorPoint - self topLeft) + resizeOffset ]

! !

!ElementsEditorFrameMorph methodsFor: 'as yet unclassified' stamp: 'jens 8/24/2009 00:07'!
mouseUp: evt

	resizeOffset _ nil.
! !

!ElementsEditorFrameMorph methodsFor: 'as yet unclassified' stamp: 'jens 8/24/2009 00:41'!
onMethod: sel ofClass: cls

	initialClass _ cls.
	initialMethod _ sel.
	self 
		withButtonsForYes: false no: false okay: true cancel: false;
		getUserResponse
! !

!ElementsEditorFrameMorph methodsFor: 'as yet unclassified' stamp: 'jens 8/24/2009 00:07'!
rememberUserDimensions
	self class setUserPos: self position size: self extent! !

!ElementsEditorFrameMorph methodsFor: 'as yet unclassified' stamp: 'jens 8/24/2009 00:07'!
snapToUserDimensions

	self extent: UserSize.
	UserPos ifNotNil: [
		self position: UserPos ].
! !

!ElementsEditorFrameMorph methodsFor: 'as yet unclassified' stamp: 'jens 8/24/2009 00:07'!
step
	resizeOffset notNil | (owner isKindOf: HandMorph)
		ifTrue: [^self ].
	self keepOnScreen 
! !

!ElementsEditorFrameMorph methodsFor: 'as yet unclassified' stamp: 'jens 8/24/2009 00:07'!
updateResizeMorph
	resizeMorph ifNotNil: [
		resizeMorph position: self bottomRight - "resizeMorph extent - " bottomRightForm width ]
! !

!ElementsEditorFrameMorph methodsFor: 'as yet unclassified' stamp: 'jens 8/24/2009 01:33'!
yes
	"Yes button was pressed."
	SyntaxElementMorph allSubInstances do: [:element |
		(element ownerThatIsA: ElementsMethodEditorMorph)
			ifNil: [element delete]].
	self rememberUserDimensions.
	super yes.! !

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

ElementsEditorFrameMorph class
	instanceVariableNames: ''!

!ElementsEditorFrameMorph class methodsFor: 'as yet unclassified' stamp: 'jens 8/24/2009 00:07'!
initialize
	"BlockEditorFrameMorph initialize"
	self resetDimensions! !

!ElementsEditorFrameMorph class methodsFor: 'as yet unclassified' stamp: 'jens 8/24/2009 00:47'!
minExtent
	^600 @ 430.! !

!ElementsEditorFrameMorph class methodsFor: 'as yet unclassified' stamp: 'jens 8/24/2009 00:07'!
resetDimensions
	UserPos _ nil.
	UserSize _ self minExtent.! !

!ElementsEditorFrameMorph class methodsFor: 'as yet unclassified' stamp: 'jens 8/24/2009 00:07'!
setUserPos: aPoint size: anExtent
	UserPos _ aPoint.
	UserSize _ anExtent.! !


ElementsEditorFrameMorph initialize!
