PaletteElementMorph subclass: #MessageHeaderElementMorph
	instanceVariableNames: 'selector labels arguments '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Elements'!

!MessageHeaderElementMorph methodsFor: 'as yet unclassified' stamp: 'jens 1/28/2009 21:53'!
asSmalltalk
	| kw ws |
	kw _ selector keywords.
	ws _ WriteStream on: String new.
	1 to: kw size do: [:i|
		ws nextPutString: (kw at: i).
		(variables size < i) ifFalse: [
			ws nextPutString: ' ', (variables at: i) asSmalltalk, ' ' ]].
	^ws contents! !

!MessageHeaderElementMorph methodsFor: 'as yet unclassified' stamp: 'jens 1/28/2009 23:06'!
beBinary
	self selector: selector arguments: #(arg)! !

!MessageHeaderElementMorph methodsFor: 'as yet unclassified' stamp: 'jens 1/28/2009 23:07'!
contextMenu
	|m|
	m _ CustomMenu new.
	m add: 'rename...' action: #editSelector.
	arguments isEmpty ifTrue: [
		m add: 'add argument' action: #beBinary ].
	^m! !

!MessageHeaderElementMorph methodsFor: 'as yet unclassified' stamp: 'jens 2/16/2009 21:05'!
editSelector
	|ans parms tokens|

	parms _ OrderedCollection new.
	ans _ FillInTheBlank request: 'selector:' initialAnswer: selector.
	ans isEmpty ifTrue: [^self].
	ans _ (SyntaxElementMorph selectorFrom: ans) asString.
	(ans includes: ($:)) ifFalse: [
		^self selector: ans arguments: #() ].

	tokens _ ans findTokens: ':'.
	1 to: tokens size do: [:i |
		parms add: 'arg', i printString ].

	self selector: ans arguments: parms.! !

!MessageHeaderElementMorph methodsFor: 'as yet unclassified' stamp: 'jens 1/14/2009 00:31'!
fit
	| cw bw bw2 x arg lb maxHeight |

	labels ifNil: [^self].
	cw _ (self labelFont widthOf: $ ) // 2.
	bw _ self borderWidth.
	bw2 _ bw * 2.

	x _ self left + bw.
	maxHeight _ self labelFont height.

	1 to: labels size do: [:i |
		lb _ labels at: i.
		lb position: x @ self center y.
		x _ lb right + cw.
		(variables size >= i)
			ifTrue: [
				arg _ variables at: i.
				maxHeight _ maxHeight max: arg height.
				arg position: x @ self center y.
				x _ arg right + cw]].

	self extent: (x - self position x - cw - bw2) @ maxHeight + (bw2 * 2).
	variables do: [:each|
		each position: (each position x @ (bounds center y - (each height // 2))) ].
	labels do: [:each|
		each position: (each position x @ (bounds center y - (each height // 2))) ].

	(owner respondsTo: #fit)
		ifTrue: [^owner fit]! !

!MessageHeaderElementMorph methodsFor: 'as yet unclassified' stamp: 'jens 1/14/2009 00:11'!
initialize
	super initialize.
	labels _ OrderedCollection new.
	variables _ OrderedCollection new.
	self fit! !

!MessageHeaderElementMorph methodsFor: 'as yet unclassified' stamp: 'jens 1/14/2009 00:14'!
labelColor
	^Color black! !

!MessageHeaderElementMorph methodsFor: 'as yet unclassified' stamp: 'jens 1/13/2009 23:39'!
labelFont
	^StrikeFont fontName: 'VerdanaBold' size: 10! !

!MessageHeaderElementMorph methodsFor: 'as yet unclassified' stamp: 'jens 1/28/2009 00:13'!
selector
	^selector! !

!MessageHeaderElementMorph methodsFor: 'as yet unclassified' stamp: 'jens 1/28/2009 22:53'!
selector: aString arguments: anArray

	"for decompilation purposes only. Caution: this method assumes that the number of arguments matches the
	number of parameters required by the selector."
	| tokens lb arg |

	selector _ aString.

	label ifNotNil: [label delete. label _ nil].
	labels do: [:each| each delete ].
	labels _ OrderedCollection new.
	arguments _ anArray.
	variables do: [:each| each delete ].
	variables _ OrderedCollection new.

	tokens _ selector findTokens: ':'.
	1 to: tokens size do: [:i |
		lb _ ((StringMorph 
				contents: (self wordsFrom: (tokens at: i)) 
				font: self labelFont) 
				color: self labelColor).
		labels add: lb.
		self addMorph: lb.
		(anArray size < i) ifFalse: [
			arg _ ObjectElementMorph new label: (anArray at: i) asString.
			arg color: owner color twiceDarker.
			variables add: arg.
			self addMorph: arg]].

	self fit
! !
