ArgMorph subclass: #MultiArgMorph
	instanceVariableNames: 'text type minArgCount defaultArgCount isWrapping '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Scratch-BYOB'!

!MultiArgMorph methodsFor: 'as yet unclassified' stamp: 'jens 2/11/2010 23:25'!
addArg: aBlockOrValue

	| newMorph newSubs |
	((aBlockOrValue isKindOf: CommandBlockMorph) or: [
		aBlockOrValue isKindOf: ArgMorph])
		ifTrue: [newMorph _ aBlockOrValue]
		ifFalse: [newMorph _ self newSlot].
	newMorph owner ifNotNil: [
		newMorph owner privateRemoveMorph: newMorph].
	newMorph layoutChanged.
	newMorph privateOwner: self.
	newSubs _ Array new: submorphs size + 1.
	1 to: submorphs size - 2 do: [:i |
		newSubs at: i put: (submorphs at: i) ].
	newSubs at: submorphs size - 1 put: newMorph.
	newSubs at: submorphs size put: self lessButton.
	newSubs at: submorphs size + 1 put: self moreButton.
	submorphs _ newSubs.
	newMorph changed.
	self layoutChanged	! !

!MultiArgMorph methodsFor: 'as yet unclassified' stamp: 'jens 4/24/2010 01:01'!
addArgSlot

	(owner isKindOf: BlockMorph) ifTrue: [
		owner stop].

	self addArg: self newSlot;
	fixArgLayout! !

!MultiArgMorph methodsFor: 'as yet unclassified' stamp: 'jens 2/15/2010 22:02'!
argMorphToReplace: aBlock
	^ self newSlot! !

!MultiArgMorph methodsFor: 'as yet unclassified' stamp: 'jens 2/12/2010 00:04'!
buildControls

	submorphs do: [:sm | sm delete].

	self addMorphBack: ((StringMorph contents: text font: (ScratchFrameMorph getFont: #Label))
		color: ((owner respondsTo: #labelColor) ifTrue: [owner labelColor] ifFalse: [Color white])).

	self addMorphBack: (ImageMorph new form: (ArgMorph dropDownMenuForm rotateBy: 90)).

	self addMorphBack: (ImageMorph new form: (ArgMorph dropDownMenuForm rotateBy: -90)).

	self fixArgLayout
! !

!MultiArgMorph methodsFor: 'as yet unclassified' stamp: 'jens 4/6/2010 23:30'!
color
	(owner respondsTo: #color) ifTrue: [
		^owner color]! !

!MultiArgMorph methodsFor: 'as yet unclassified' stamp: 'jens 6/24/2010 23:18'!
contrastColor
	submorphs do: [:m |	(m isKindOf: BlockMorph)
		ifTrue: [ m contrastColor ]]! !

!MultiArgMorph methodsFor: 'as yet unclassified' stamp: 'jens 2/11/2010 22:08'!
defaultArgCount
	^ defaultArgCount! !

!MultiArgMorph methodsFor: 'as yet unclassified' stamp: 'jens 2/11/2010 22:08'!
defaultArgCount: anInt
	defaultArgCount _ anInt! !

!MultiArgMorph methodsFor: 'as yet unclassified' stamp: 'jens 2/7/2011 00:40'!
defaultValue: aScratchListMorph
	"Set my default value"

	| element |

	(aScratchListMorph isKindOf: ScratchListMorph)
		ifFalse: [^ self].
	1 to: aScratchListMorph lineCount do: [:i |
		element _ aScratchListMorph lineAt: i.
		((element isKindOf: ReporterBlockMorph)
		and: [(element isKindOf: ArgMorph) not])
			ifTrue: [self addArg: element]
			ifFalse: [
				self addArgSlot.
				(element isKindOf: ReporterBlockMorph)
					ifTrue: [((element respondsTo: #body) and: [element body notNil])
						ifTrue: [
							self replaceSubmorph: self elements last by: element 
							"self elements last replaceArgMorph: self elements last args first by: element body"]]
					ifFalse: [ 
						element = 'nil' asUTF8
							ifTrue: [element _ nil].
						self elements last defaultValue: element ]]]
		! !

!MultiArgMorph methodsFor: 'as yet unclassified' stamp: 'jens 2/10/2010 23:44'!
elements
	^ submorphs reject: [:sm |
		(sm isKindOf: ImageMorph)
		or: [sm isKindOf: StringMorph]]! !

!MultiArgMorph methodsFor: 'as yet unclassified' stamp: 'jens 9/14/2010 02:12'!
evaluate
	 | list |

	(self isEmptySlot and: [implicitValue notNil])
		ifTrue: [^implicitValue].

	list _ ScratchListMorph new.
	list listName: '' target: nil.
	self elements do: [:each |
		list insertLine:  (ScriptableScratchMorph new asListElement: each evaluate) at: (list lineCount + 1) ].
	list updateCountMorph.
	list fixLayout.
	list startStepping.
	^list	! !

!MultiArgMorph methodsFor: 'as yet unclassified' stamp: 'CWB 8/8/2011 13:40'!
exportArgWith: anExporter havingSpec: aSpec
	"Exports the given argument"
	"A MultiArgMorph is, in fact, a list of elements, so this exports a list."

	| length count |

	anExporter outputTranslationOfTerm: 'list start'.

	length _ self elements size.
	count _ 1.

	self elements do: [:elem |

		anExporter outputTranslationOfTerm: 'list element start'.
		anExporter exportArgument: elem havingSpec: ''.
		anExporter outputTranslationOfTerm: 'list element end'.

		"Don't place a separator after the final element"
		(count < length) ifTrue: [
			anExporter outputTranslationOfTerm: 'list element separator'.
		].
		count _ count + 1.
	].	

	anExporter outputTranslationOfTerm: 'list end'.
! !

!MultiArgMorph methodsFor: 'as yet unclassified' stamp: 'jens 4/22/2010 00:51'!
fixArgLayoutNoWrap

	| maxHeight newWidth x space shouldHide visible |

	x _ self left.
	space _ 4.
	shouldHide _ (submorphs size - 3 > minArgCount) not.
	self lessButton isHidden: shouldHide.
	self label isHidden: shouldHide.
	visible _ submorphs select: [:sm| sm isVisible].
	maxHeight _ (visible collect: [:sm | sm height]) max.
	visible do: [: sm |
		(sm = self label or: [| e | e _ self elements. e isEmpty or: [sm = e first]]) 
			ifTrue: [ x _ x - 2]
			ifFalse: [ x _ x + space].
		sm position: x @ (self top + (maxHeight - sm height // 2)).
		sm changed.
		x _ x + sm width].
	newWidth _ x - self left.
	self extent: newWidth @ maxHeight.
	self layoutChanged.
	owner ifNotNil: [owner layoutChanged].

! !

!MultiArgMorph methodsFor: 'as yet unclassified' stamp: 'jens 2/12/2010 00:13'!
handlesMouseDown: evt

	| more less |
	more _ self moreButton.
	less _ self lessButton.
	^ (more isVisible & (more containsPoint: evt cursorPoint))
		or: [less isVisible & (less containsPoint: evt cursorPoint)]
! !

!MultiArgMorph methodsFor: 'as yet unclassified' stamp: 'jens 4/21/2010 23:44'!
initialize

	super initialize.
	isWrapping _ false.
	self color: Color transparent.
	self borderWidth: 0.
	text _ ''.
	type _ #any.
	minArgCount _ 0.
	defaultArgCount _ 1.
	self buildControls.
! !

!MultiArgMorph methodsFor: 'as yet unclassified' stamp: 'jens 2/22/2010 01:03'!
isEmptySlot


	^self elements isEmpty! !

!MultiArgMorph methodsFor: 'as yet unclassified' stamp: 'jens 9/22/2010 02:30'!
isLambdaForm
	^false! !

!MultiArgMorph methodsFor: 'as yet unclassified' stamp: 'jens 4/21/2010 23:44'!
isWrapping
	^isWrapping
! !

!MultiArgMorph methodsFor: 'as yet unclassified' stamp: 'jens 2/10/2010 23:45'!
label
	^ submorphs first! !

!MultiArgMorph methodsFor: 'as yet unclassified' stamp: 'jens 2/11/2010 22:18'!
lessButton
	^ submorphs at: submorphs size - 1! !

!MultiArgMorph methodsFor: 'as yet unclassified' stamp: 'jens 9/14/2010 02:14'!
listValue
	 | list item |
	list _ ScratchListMorph new.
	list listName: '' target: nil.
	self elements do: [:each |
		(each isKindOf: ReporterBlockMorph)
			ifTrue: [item _ each]
			ifFalse: [each isEmptySlot
				ifTrue: [item _ nil]
				ifFalse: [item _ each evaluate]].
		list insertLine: (ScriptableScratchMorph new asListElement: item) at: (list lineCount + 1) ].
	list updateCountMorph.
	^list	! !

!MultiArgMorph methodsFor: 'as yet unclassified' stamp: 'jens 7/7/2010 00:13'!
loopsWidth: anInteger

	| parts |

	type = #loop ifFalse: [^ self].
	self width: (anInteger max: 50).
	parts _ submorphs select: [:sm | (sm isKindOf: CArgSlotMorph) or: [sm isKindOf: CReporterSlotMorph]].
	parts do: [:m |
		m width: self width ]
! !

!MultiArgMorph methodsFor: 'as yet unclassified' stamp: 'jens 2/11/2010 22:08'!
minArgCount
	^ minArgCount! !

!MultiArgMorph methodsFor: 'as yet unclassified' stamp: 'jens 2/11/2010 22:07'!
minArgCount: anInt
	minArgCount _ anInt! !

!MultiArgMorph methodsFor: 'as yet unclassified' stamp: 'jens 2/11/2010 22:18'!
moreButton
	^ submorphs at: submorphs size! !

!MultiArgMorph methodsFor: 'as yet unclassified' stamp: 'jens 2/11/2010 23:26'!
mouseDown: evt
	"Handle a mouse click. Left button either drags or performs click action. Right button brings up a menu."

	evt hand newKeyboardFocus: nil.
	evt anyButtonPressed ifTrue: [
		(self moreButton containsPoint: evt cursorPoint)
			ifTrue: [^self addArgSlot ].
		(self lessButton containsPoint: evt cursorPoint)
			ifTrue: [^self removeArgSlot ]].
	^super mouseDown: evt
! !

!MultiArgMorph methodsFor: 'as yet unclassified' stamp: 'JM 8/3/2011 16:50'!
newSlot

	| specs slot |
	specs _ Dictionary new.
	specs
		at: #command put: '%o';
		at: #reporter put: '%r';
		at: #predicate put: '%6';
		at: #list put: '%t';
		at: #text put: '%T';
		at: #any put: '%s';
		at: #boolean put: '%b';
		at: #number put: '%n';
		at: #loop put: '%G';
		at: #unevaluated put: '%j';
		at: #unevaluatedBoolean put: '%Q';
		at: #objSlot put: '%1'.

" +++ deprecated experimental slots    -jens ++++++

		at: #reporterSlot put: '%K';
		at: #typeInReporter put: '%j'.

+++++++++++++++++++++++++++++++++++++++++++++++"

	slot _ CommandBlockMorph new uncoloredArgMorphFor: (specs at: type ifAbsent: [ '%s']).
	slot defaultValue: ''.
	^slot! !

!MultiArgMorph methodsFor: 'as yet unclassified' stamp: 'jens 4/24/2010 01:00'!
removeArgSlot

	| oldArg  |

	(owner isKindOf: BlockMorph) ifTrue: [
		owner stop].

	oldArg _ submorphs at: submorphs size - 2.
	((oldArg isKindOf: BlockMorph) and: [(oldArg isKindOf: ArgMorph) not])
		ifTrue: [World addMorph: oldArg]
		ifFalse: [oldArg delete].
	self fixArgLayout! !

!MultiArgMorph methodsFor: 'as yet unclassified' stamp: 'jens 2/15/2010 03:59'!
replaceArgMorph: oldArg by: newArg

	self replaceSubmorph: oldArg by: newArg
! !

!MultiArgMorph methodsFor: 'as yet unclassified' stamp: 'jens 6/28/2010 21:51'!
tabFields

	| fields |
	fields _	OrderedCollection new.
	submorphs do: [:m |
		(m isKindOf: ReporterBlockMorph)
			ifTrue: [fields addAll: m tabFields ]
			ifFalse: [(m isKindOf: ExpressionArgMorph)
				ifTrue: [fields add: m]]].
	^ fields! !

!MultiArgMorph methodsFor: 'as yet unclassified' stamp: 'jens 2/11/2010 22:51'!
text
	^ text! !

!MultiArgMorph methodsFor: 'as yet unclassified' stamp: 'jens 2/11/2010 22:50'!
text: aString
	text _ aString! !

!MultiArgMorph methodsFor: 'as yet unclassified' stamp: 'jens 3/22/2010 14:29'!
topBlock

	(owner isKindOf: BlockMorph) ifTrue: [
		^owner topBlock].
	^nil
! !

!MultiArgMorph methodsFor: 'as yet unclassified' stamp: 'jens 4/22/2010 15:32'!
transparentRect
	^ self position corner: (self right@submorphs last top)! !

!MultiArgMorph methodsFor: 'as yet unclassified' stamp: 'jens 2/10/2010 23:08'!
type
	^type! !

!MultiArgMorph methodsFor: 'as yet unclassified' stamp: 'jens 2/14/2011 01:36'!
type: aSymbol

	"currently BYOB supports the following first class types:

    #none			- a puzzle shaped command block
    #any			- a non-typed round reporter block (can be anything)
    #string			- a round reporter block that answers a string
    #number		- a round reporter block that answers a number
    #list				- a round reporter block that answers a number
    #boolean		- a hexagonal reporter block that answers a boolean
    #command		- a round reporter block that answers a procedure (a command block)
    #reporter		- a round reporter block that answers a function (a reporter block)
    #predicate		- a hexagonal reporter block that answers a reporter of a boolean 
    #template		- a sunken variable blob that represents an externalized block variable
    #loop			- a C-shaped slot
    #reporterSlot		- a C-shaped reporter slot
    #typeInReporter	- a rectangular reporter slot that can be typed into
    #unevaluated	- a rectangular type-in slot that auto-lambdafies
    #unevaluatedBoolean
    #objSlot

"

	type _ aSymbol! !


!MultiArgMorph methodsFor: 'error handling' stamp: 'jens 3/22/2010 14:32'!
receiver

	"needed for error handling"
	(owner isKindOf: BlockMorph) ifTrue: [
		^owner receiver].
	^nil

! !

!MultiArgMorph methodsFor: 'error handling' stamp: 'jens 3/22/2010 14:36'!
showError
	"Make this block to show an error."

	(owner isKindOf: BlockMorph) ifTrue: [
		owner showError]! !


!MultiArgMorph methodsFor: 'as yet unclassified' stamp: 'jens 2/11/2010 23:25'!
addArg: aBlockOrValue

	| newMorph newSubs |
	((aBlockOrValue isKindOf: CommandBlockMorph) or: [
		aBlockOrValue isKindOf: ArgMorph])
		ifTrue: [newMorph _ aBlockOrValue]
		ifFalse: [newMorph _ self newSlot].
	newMorph owner ifNotNil: [
		newMorph owner privateRemoveMorph: newMorph].
	newMorph layoutChanged.
	newMorph privateOwner: self.
	newSubs _ Array new: submorphs size + 1.
	1 to: submorphs size - 2 do: [:i |
		newSubs at: i put: (submorphs at: i) ].
	newSubs at: submorphs size - 1 put: newMorph.
	newSubs at: submorphs size put: self lessButton.
	newSubs at: submorphs size + 1 put: self moreButton.
	submorphs _ newSubs.
	newMorph changed.
	self layoutChanged	! !

!MultiArgMorph methodsFor: 'as yet unclassified' stamp: 'jens 4/24/2010 01:01'!
addArgSlot

	(owner isKindOf: BlockMorph) ifTrue: [
		owner stop].

	self addArg: self newSlot;
	fixArgLayout! !

!MultiArgMorph methodsFor: 'as yet unclassified' stamp: 'jens 2/15/2010 22:02'!
argMorphToReplace: aBlock
	^ self newSlot! !

!MultiArgMorph methodsFor: 'as yet unclassified' stamp: 'jens 2/12/2010 00:04'!
buildControls

	submorphs do: [:sm | sm delete].

	self addMorphBack: ((StringMorph contents: text font: (ScratchFrameMorph getFont: #Label))
		color: ((owner respondsTo: #labelColor) ifTrue: [owner labelColor] ifFalse: [Color white])).

	self addMorphBack: (ImageMorph new form: (ArgMorph dropDownMenuForm rotateBy: 90)).

	self addMorphBack: (ImageMorph new form: (ArgMorph dropDownMenuForm rotateBy: -90)).

	self fixArgLayout
! !

!MultiArgMorph methodsFor: 'as yet unclassified' stamp: 'jens 4/6/2010 23:30'!
color
	(owner respondsTo: #color) ifTrue: [
		^owner color]! !

!MultiArgMorph methodsFor: 'as yet unclassified' stamp: 'jens 6/24/2010 23:18'!
contrastColor
	submorphs do: [:m |	(m isKindOf: BlockMorph)
		ifTrue: [ m contrastColor ]]! !

!MultiArgMorph methodsFor: 'as yet unclassified' stamp: 'jens 2/11/2010 22:08'!
defaultArgCount
	^ defaultArgCount! !

!MultiArgMorph methodsFor: 'as yet unclassified' stamp: 'jens 2/11/2010 22:08'!
defaultArgCount: anInt
	defaultArgCount _ anInt! !

!MultiArgMorph methodsFor: 'as yet unclassified' stamp: 'jens 2/7/2011 00:40'!
defaultValue: aScratchListMorph
	"Set my default value"

	| element |

	(aScratchListMorph isKindOf: ScratchListMorph)
		ifFalse: [^ self].
	1 to: aScratchListMorph lineCount do: [:i |
		element _ aScratchListMorph lineAt: i.
		((element isKindOf: ReporterBlockMorph)
		and: [(element isKindOf: ArgMorph) not])
			ifTrue: [self addArg: element]
			ifFalse: [
				self addArgSlot.
				(element isKindOf: ReporterBlockMorph)
					ifTrue: [((element respondsTo: #body) and: [element body notNil])
						ifTrue: [
							self replaceSubmorph: self elements last by: element 
							"self elements last replaceArgMorph: self elements last args first by: element body"]]
					ifFalse: [ 
						element = 'nil' asUTF8
							ifTrue: [element _ nil].
						self elements last defaultValue: element ]]]
		! !

!MultiArgMorph methodsFor: 'as yet unclassified' stamp: 'jens 2/10/2010 23:44'!
elements
	^ submorphs reject: [:sm |
		(sm isKindOf: ImageMorph)
		or: [sm isKindOf: StringMorph]]! !

!MultiArgMorph methodsFor: 'as yet unclassified' stamp: 'jens 9/14/2010 02:12'!
evaluate
	 | list |

	(self isEmptySlot and: [implicitValue notNil])
		ifTrue: [^implicitValue].

	list _ ScratchListMorph new.
	list listName: '' target: nil.
	self elements do: [:each |
		list insertLine:  (ScriptableScratchMorph new asListElement: each evaluate) at: (list lineCount + 1) ].
	list updateCountMorph.
	list fixLayout.
	list startStepping.
	^list	! !

!MultiArgMorph methodsFor: 'as yet unclassified' stamp: 'CWB 8/8/2011 13:40'!
exportArgWith: anExporter havingSpec: aSpec
	"Exports the given argument"
	"A MultiArgMorph is, in fact, a list of elements, so this exports a list."

	| length count |

	anExporter outputTranslationOfTerm: 'list start'.

	length _ self elements size.
	count _ 1.

	self elements do: [:elem |

		anExporter outputTranslationOfTerm: 'list element start'.
		anExporter exportArgument: elem havingSpec: ''.
		anExporter outputTranslationOfTerm: 'list element end'.

		"Don't place a separator after the final element"
		(count < length) ifTrue: [
			anExporter outputTranslationOfTerm: 'list element separator'.
		].
		count _ count + 1.
	].	

	anExporter outputTranslationOfTerm: 'list end'.
! !

!MultiArgMorph methodsFor: '-- all --' stamp: 'jens 7/7/2010 00:06'!
fixArgLayout

	| maxHeight x space shouldHide lines line left maxX parts w y mh h isMultiC |

	shouldHide _ (submorphs size - 3 > minArgCount) not.
	self lessButton isHidden: shouldHide.
	self label isHidden: shouldHide.
	isMultiC _ #(loop reporterSlot) includes: type.
	lines _ OrderedCollection new.


	"distribute parts horizontally and cut up into lines"

	line _ OrderedCollection new.
	x _ self left.
	left _ x.
	maxX _ x.
	space _ 4.

	isMultiC ifTrue: [
		self width: 50 ].

	parts _ submorphs select: [:sm| sm isVisible and: [(sm isKindOf: StringMorph) not]].

	parts do: [:m |
	(m isKindOf: ReporterBlockMorph) & isMultiC
		ifTrue: [ "in this case just break up into lines, don't distribute yet"
			m left: self left.
			lines add: (OrderedCollection with: m).
			m fixBlockLayout.
			((m isKindOf: CArgSlotMorph) or: [m isKindOf: CReporterSlotMorph]) ifTrue: [
				m width: self width].
			maxX _ maxX max: left + m width.
			x _ left ]
		ifFalse: [
			(x - left > 300 and: [m ~~ submorphs last]) ifTrue: [
				lines add: line.
				line _ OrderedCollection new.
				x _ left].
			(m isKindOf: BlockMorph) ifTrue: [m fixBlockLayout].
			(m isKindOf: ArgMorph) ifTrue: [m fixArgLayout].

			m left: x.
			(m right - left > 300 and: [line isEmpty not and: [m ~~ submorphs last]])
				ifTrue: [
					lines add: line.
					line _ OrderedCollection new.
					m left: left.
					line add: m.
					x _ left]
				ifFalse: [ line add: m].
				x _ x + m fullBounds width + space.
				maxX _ maxX max: x]].

	x = left ifFalse: [
		lines add: line].
	w _ maxX - self left max: 4.

	isWrapping _ lines size > 1.

	"distribute lines vertically"

	space _ 0.
	y _ self top.
	isWrapping & isMultiC not ifTrue: [
		space _ 1.
		y _ self top + 2].
	lines do: [:eachLine |
		maxHeight _ 10.
		eachLine do: [:m |
			((m isKindOf: ReporterBlockMorph)
			and: [m isBlockTemplate and: [m isEmptySlot not]])
				ifTrue: [mh _ m height + 7]
				ifFalse: [mh _ m height].
			maxHeight _ mh max: maxHeight].
		eachLine do: [:m |
			m top: y + (maxHeight - m height // 2)].
		y _ y + maxHeight + space].
	h _ y - self top + space.

	self extent: w @ h.

	self layoutChanged.
	owner ifNotNil: [owner layoutChanged].

! !

!MultiArgMorph methodsFor: 'as yet unclassified' stamp: 'jens 4/22/2010 00:51'!
fixArgLayoutNoWrap

	| maxHeight newWidth x space shouldHide visible |

	x _ self left.
	space _ 4.
	shouldHide _ (submorphs size - 3 > minArgCount) not.
	self lessButton isHidden: shouldHide.
	self label isHidden: shouldHide.
	visible _ submorphs select: [:sm| sm isVisible].
	maxHeight _ (visible collect: [:sm | sm height]) max.
	visible do: [: sm |
		(sm = self label or: [| e | e _ self elements. e isEmpty or: [sm = e first]]) 
			ifTrue: [ x _ x - 2]
			ifFalse: [ x _ x + space].
		sm position: x @ (self top + (maxHeight - sm height // 2)).
		sm changed.
		x _ x + sm width].
	newWidth _ x - self left.
	self extent: newWidth @ maxHeight.
	self layoutChanged.
	owner ifNotNil: [owner layoutChanged].

! !

!MultiArgMorph methodsFor: 'as yet unclassified' stamp: 'jens 2/12/2010 00:13'!
handlesMouseDown: evt

	| more less |
	more _ self moreButton.
	less _ self lessButton.
	^ (more isVisible & (more containsPoint: evt cursorPoint))
		or: [less isVisible & (less containsPoint: evt cursorPoint)]
! !

!MultiArgMorph methodsFor: 'as yet unclassified' stamp: 'jens 4/21/2010 23:44'!
initialize

	super initialize.
	isWrapping _ false.
	self color: Color transparent.
	self borderWidth: 0.
	text _ ''.
	type _ #any.
	minArgCount _ 0.
	defaultArgCount _ 1.
	self buildControls.
! !

!MultiArgMorph methodsFor: 'as yet unclassified' stamp: 'jens 2/22/2010 01:03'!
isEmptySlot


	^self elements isEmpty! !

!MultiArgMorph methodsFor: 'as yet unclassified' stamp: 'jens 9/22/2010 02:30'!
isLambdaForm
	^false! !

!MultiArgMorph methodsFor: 'as yet unclassified' stamp: 'jens 4/21/2010 23:44'!
isWrapping
	^isWrapping
! !

!MultiArgMorph methodsFor: 'as yet unclassified' stamp: 'jens 2/10/2010 23:45'!
label
	^ submorphs first! !

!MultiArgMorph methodsFor: 'as yet unclassified' stamp: 'jens 2/11/2010 22:18'!
lessButton
	^ submorphs at: submorphs size - 1! !

!MultiArgMorph methodsFor: 'as yet unclassified' stamp: 'jens 9/14/2010 02:14'!
listValue
	 | list item |
	list _ ScratchListMorph new.
	list listName: '' target: nil.
	self elements do: [:each |
		(each isKindOf: ReporterBlockMorph)
			ifTrue: [item _ each]
			ifFalse: [each isEmptySlot
				ifTrue: [item _ nil]
				ifFalse: [item _ each evaluate]].
		list insertLine: (ScriptableScratchMorph new asListElement: item) at: (list lineCount + 1) ].
	list updateCountMorph.
	^list	! !

!MultiArgMorph methodsFor: 'as yet unclassified' stamp: 'jens 7/7/2010 00:13'!
loopsWidth: anInteger

	| parts |

	type = #loop ifFalse: [^ self].
	self width: (anInteger max: 50).
	parts _ submorphs select: [:sm | (sm isKindOf: CArgSlotMorph) or: [sm isKindOf: CReporterSlotMorph]].
	parts do: [:m |
		m width: self width ]
! !

!MultiArgMorph methodsFor: 'as yet unclassified' stamp: 'jens 2/11/2010 22:08'!
minArgCount
	^ minArgCount! !

!MultiArgMorph methodsFor: 'as yet unclassified' stamp: 'jens 2/11/2010 22:07'!
minArgCount: anInt
	minArgCount _ anInt! !

!MultiArgMorph methodsFor: 'as yet unclassified' stamp: 'jens 2/11/2010 22:18'!
moreButton
	^ submorphs at: submorphs size! !

!MultiArgMorph methodsFor: 'geometry' stamp: 'CWB 11/9/2012 22:15'!
morphEndsLine
"This morph should be the only one on its line (not counting children) if it is wrapping."

	^ self isWrapping.! !

!MultiArgMorph methodsFor: 'geometry' stamp: 'CWB 11/9/2012 22:15'!
morphStartsNewLine
"This morph should be the only one on its line (not counting children) if it is wrapping."

	^ self isWrapping.! !

!MultiArgMorph methodsFor: 'as yet unclassified' stamp: 'jens 2/11/2010 23:26'!
mouseDown: evt
	"Handle a mouse click. Left button either drags or performs click action. Right button brings up a menu."

	evt hand newKeyboardFocus: nil.
	evt anyButtonPressed ifTrue: [
		(self moreButton containsPoint: evt cursorPoint)
			ifTrue: [^self addArgSlot ].
		(self lessButton containsPoint: evt cursorPoint)
			ifTrue: [^self removeArgSlot ]].
	^super mouseDown: evt
! !

!MultiArgMorph methodsFor: 'as yet unclassified' stamp: 'JM 8/3/2011 16:50'!
newSlot

	| specs slot |
	specs _ Dictionary new.
	specs
		at: #command put: '%o';
		at: #reporter put: '%r';
		at: #predicate put: '%6';
		at: #list put: '%t';
		at: #text put: '%T';
		at: #any put: '%s';
		at: #boolean put: '%b';
		at: #number put: '%n';
		at: #loop put: '%G';
		at: #unevaluated put: '%j';
		at: #unevaluatedBoolean put: '%Q';
		at: #objSlot put: '%1'.

" +++ deprecated experimental slots    -jens ++++++

		at: #reporterSlot put: '%K';
		at: #typeInReporter put: '%j'.

+++++++++++++++++++++++++++++++++++++++++++++++"

	slot _ CommandBlockMorph new uncoloredArgMorphFor: (specs at: type ifAbsent: [ '%s']).
	slot defaultValue: ''.
	^slot! !

!MultiArgMorph methodsFor: 'geometry' stamp: 'CWB 11/12/2012 10:46'!
parentsFinalLineWidth: linewidth
	"Some morphs adjust their width when they know 
	how wide the line they are on is."

	self loopsWidth: linewidth - 5.! !

!MultiArgMorph methodsFor: 'error handling' stamp: 'jens 3/22/2010 14:32'!
receiver

	"needed for error handling"
	(owner isKindOf: BlockMorph) ifTrue: [
		^owner receiver].
	^nil

! !

!MultiArgMorph methodsFor: 'as yet unclassified' stamp: 'jens 4/24/2010 01:00'!
removeArgSlot

	| oldArg  |

	(owner isKindOf: BlockMorph) ifTrue: [
		owner stop].

	oldArg _ submorphs at: submorphs size - 2.
	((oldArg isKindOf: BlockMorph) and: [(oldArg isKindOf: ArgMorph) not])
		ifTrue: [World addMorph: oldArg]
		ifFalse: [oldArg delete].
	self fixArgLayout! !

!MultiArgMorph methodsFor: 'as yet unclassified' stamp: 'jens 2/15/2010 03:59'!
replaceArgMorph: oldArg by: newArg

	self replaceSubmorph: oldArg by: newArg
! !

!MultiArgMorph methodsFor: 'error handling' stamp: 'jens 3/22/2010 14:36'!
showError
	"Make this block to show an error."

	(owner isKindOf: BlockMorph) ifTrue: [
		owner showError]! !

!MultiArgMorph methodsFor: 'as yet unclassified' stamp: 'jens 6/28/2010 21:51'!
tabFields

	| fields |
	fields _	OrderedCollection new.
	submorphs do: [:m |
		(m isKindOf: ReporterBlockMorph)
			ifTrue: [fields addAll: m tabFields ]
			ifFalse: [(m isKindOf: ExpressionArgMorph)
				ifTrue: [fields add: m]]].
	^ fields! !

!MultiArgMorph methodsFor: 'as yet unclassified' stamp: 'jens 2/11/2010 22:51'!
text
	^ text! !

!MultiArgMorph methodsFor: 'as yet unclassified' stamp: 'jens 2/11/2010 22:50'!
text: aString
	text _ aString! !

!MultiArgMorph methodsFor: 'as yet unclassified' stamp: 'jens 3/22/2010 14:29'!
topBlock

	(owner isKindOf: BlockMorph) ifTrue: [
		^owner topBlock].
	^nil
! !

!MultiArgMorph methodsFor: 'as yet unclassified' stamp: 'jens 4/22/2010 15:32'!
transparentRect
	^ self position corner: (self right@submorphs last top)! !

!MultiArgMorph methodsFor: 'as yet unclassified' stamp: 'jens 2/10/2010 23:08'!
type
	^type! !

!MultiArgMorph methodsFor: 'as yet unclassified' stamp: 'jens 2/14/2011 01:36'!
type: aSymbol

	"currently BYOB supports the following first class types:

    #none			- a puzzle shaped command block
    #any			- a non-typed round reporter block (can be anything)
    #string			- a round reporter block that answers a string
    #number		- a round reporter block that answers a number
    #list				- a round reporter block that answers a number
    #boolean		- a hexagonal reporter block that answers a boolean
    #command		- a round reporter block that answers a procedure (a command block)
    #reporter		- a round reporter block that answers a function (a reporter block)
    #predicate		- a hexagonal reporter block that answers a reporter of a boolean 
    #template		- a sunken variable blob that represents an externalized block variable
    #loop			- a C-shaped slot
    #reporterSlot		- a C-shaped reporter slot
    #typeInReporter	- a rectangular reporter slot that can be typed into
    #unevaluated	- a rectangular type-in slot that auto-lambdafies
    #unevaluatedBoolean
    #objSlot

"

	type _ aSymbol! !


!MultiArgMorph methodsFor: 'geometry' stamp: 'CWB 11/9/2012 22:15'!
morphEndsLine
"This morph should be the only one on its line (not counting children) if it is wrapping."

	^ self isWrapping.! !

!MultiArgMorph methodsFor: 'geometry' stamp: 'CWB 11/9/2012 22:15'!
morphStartsNewLine
"This morph should be the only one on its line (not counting children) if it is wrapping."

	^ self isWrapping.! !

!MultiArgMorph methodsFor: 'geometry' stamp: 'CWB 11/12/2012 10:46'!
parentsFinalLineWidth: linewidth
	"Some morphs adjust their width when they know 
	how wide the line they are on is."

	self loopsWidth: linewidth - 5.! !

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

MultiArgMorph class
	instanceVariableNames: ''!

!MultiArgMorph class methodsFor: 'as yet unclassified' stamp: 'jens 2/15/2010 23:49'!
type: aSymbol
	^ self new
		type: aSymbol;
		text: '';
		buildControls! !
