StringDialog subclass: #BlockDialog
	instanceVariableNames: 'allSpritesRadioButton thisSpriteRadioButton spriteSpecificFlag scopeRadioButtons radioButtons commandBlockRadioButton reporterBlockRadioButton booleanBlockRadioButton booleanBlockFlag reporterBlockFlag categoryChooser category userSpec type '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Scratch-BYOB'!

!BlockDialog methodsFor: 'private' stamp: 'jens 1/25/2010 02:32'!
formTypeCommandOff

	^ (CommandBlockMorph new 
			color: ((ScriptableScratchMorph blockColorFor: category asString) mixed: 0.2 with: Color veryLightGray); 
			commandSpec: 'command' localized) 
		imageForm.
! !

!BlockDialog methodsFor: 'private' stamp: 'jens 1/25/2010 01:27'!
formTypeCommandOn

	^ (CommandBlockMorph new
			color: (ScriptableScratchMorph blockColorFor: category asString); 
			commandSpec: 'command' localized) 
		imageForm.
! !

!BlockDialog methodsFor: 'private' stamp: 'jens 6/22/2010 22:51'!
formTypeCommandOver

	^ (CommandBlockMorph new 
			color: ((ScriptableScratchMorph blockColorFor: category asString) mixed: 0.4 with: Color veryLightGray); 
			commandSpec: 'command' localized) 
		imageForm.
! !

!BlockDialog methodsFor: 'private' stamp: 'jens 1/25/2010 02:32'!
formTypePredicateOff

	^ (ReporterBlockMorph new 
			isBoolean: true; 
			color: ((ScriptableScratchMorph blockColorFor: category asString) mixed: 0.2 with: Color veryLightGray); 
			commandSpec: 'predicate' localized) 
		imageForm.
! !

!BlockDialog methodsFor: 'private' stamp: 'jens 1/25/2010 01:49'!
formTypePredicateOn

	^ (ReporterBlockMorph new 
			isBoolean: true; 
			color: (ScriptableScratchMorph blockColorFor: category asString); 
			commandSpec: 'predicate' localized) 
		imageForm.
! !

!BlockDialog methodsFor: 'private' stamp: 'jens 6/22/2010 22:52'!
formTypePredicateOver

	^ (ReporterBlockMorph new 
			isBoolean: true; 
			color: ((ScriptableScratchMorph blockColorFor: category asString) mixed: 0.4 with: Color veryLightGray); 
			commandSpec: 'predicate' localized) 
		imageForm.! !

!BlockDialog methodsFor: 'private' stamp: 'jens 1/25/2010 02:33'!
formTypeReporterOff

	^ (ReporterBlockMorph new 
			color: ((ScriptableScratchMorph blockColorFor: category asString) mixed: 0.2 with: Color veryLightGray); 
			commandSpec: 'reporter' localized) 
		imageForm.
! !

!BlockDialog methodsFor: 'private' stamp: 'jens 1/11/2010 01:35'!
formTypeReporterOn

	^ (ReporterBlockMorph new color: (ScriptableScratchMorph blockColorFor: category asString); commandSpec: 'reporter' localized) imageForm.
! !

!BlockDialog methodsFor: 'private' stamp: 'jens 6/22/2010 22:52'!
formTypeReporterOver

	^ (ReporterBlockMorph new 
			color: ((ScriptableScratchMorph blockColorFor: category asString) mixed: 0.4 with: Color veryLightGray); 
			commandSpec: 'reporter' localized) 
		imageForm.
! !

!BlockDialog methodsFor: 'private' stamp: 'jens 2/2/2010 22:01'!
selectBooleanBlock

	reporterBlockFlag _ true.
	booleanBlockFlag _ true.
	type _ #boolean.
	booleanBlockRadioButton
		onForm: self formTypePredicateOn;
		overForm: self formTypePredicateOn;
		on.
	commandBlockRadioButton
		offForm: self formTypeCommandOff;
		overForm: self formTypeCommandOver;
		off.
	reporterBlockRadioButton
		offForm: self formTypeReporterOff;
		overForm: self formTypeReporterOver;
		off.
	World activeHand newKeyboardFocus: tabFields first.
! !

!BlockDialog methodsFor: 'private' stamp: 'jens 2/2/2010 22:01'!
selectCommandBlock

	reporterBlockFlag _ false.
	booleanBlockFlag _ false.
	type _ #none.
	booleanBlockRadioButton
		offForm: self formTypePredicateOff;
		overForm: self formTypePredicateOver;
		off.
	commandBlockRadioButton
		onForm: self formTypeCommandOn;
		overForm: self formTypeCommandOn;
		on.
	reporterBlockRadioButton
		offForm: self formTypeReporterOff;
		overForm: self formTypeReporterOver;
		off.
	World activeHand newKeyboardFocus: tabFields first.
! !

!BlockDialog methodsFor: 'private' stamp: 'jens 2/2/2010 22:01'!
selectReporterBlock

	reporterBlockFlag _ true.
	booleanBlockFlag _ false.
	type _ #reporter.
	booleanBlockRadioButton
		offForm: self formTypePredicateOff;
		overForm: self formTypePredicateOver;
		off.
	commandBlockRadioButton
		offForm: self formTypeCommandOff;
		overForm: self formTypeCommandOver;
		off.
	reporterBlockRadioButton
		onForm: self formTypeReporterOn;
		overForm: self formTypeReporterOn;
		on.
	World activeHand newKeyboardFocus: tabFields first.
! !

!BlockDialog methodsFor: 'private' stamp: 'jens 2/2/2010 22:01'!
toggleSpriteSpecific

	spriteSpecificFlag _ spriteSpecificFlag not.
	spriteSpecificFlag
		ifTrue: [
			allSpritesRadioButton off.
			thisSpriteRadioButton on]
		ifFalse: [
			allSpritesRadioButton on.
			thisSpriteRadioButton off].
	World activeHand newKeyboardFocus: tabFields first.
! !

!BlockDialog methodsFor: 'private' stamp: 'jens 1/11/2010 01:42'!
updateTypeSelection
	#none = type ifTrue: [
		^self selectCommandBlock].

	#boolean = type ifTrue: [
		^self selectBooleanBlock].

	self selectReporterBlock! !


!BlockDialog methodsFor: 'initialization' stamp: 'CWB 12/20/2012 10:31'!
buildCategoryChooser

	"Builds the list of categories in the upper-left-hand corner of Enchanting."
	"Please update ScratchViewerMorph>>rebuildCategorySelectors whenever you update this."

	| catList maxExtent buttons label offForm onForm overForm b pad leftColumnX rightColumnX x y catButtonsExtent |
	catList _ #(
		control		motion
		driving		looks
		sensing		sound
		motors		pen
		operators	variables
	).

	categoryChooser _ ImageFrameMorph new.
	categoryChooser initFromForm: (ScratchFrameMorph skinAt: #paintOptionsBackground).

	"Create new buttons, keeping track of the maximum extent."
	maxExtent _ 75@0.
	buttons _ catList collect: [:cat |
		label _ (ScratchTranslator translationFor: cat asString) capitalized.

		(#(other list) includes: cat)
			ifTrue:[
				offForm _ (ScratchFrameMorph skinAt: #variables).
				onForm _ (ScratchFrameMorph skinAt: #variablesPressed).
				overForm _ (ScratchFrameMorph skinAt: #variablesOver)]
			ifFalse: [
				offForm _ (ScratchFrameMorph skinAt: cat).
				onForm _ (ScratchFrameMorph skinAt: (cat, 'Pressed')).
				overForm _ (ScratchFrameMorph skinAt: (cat, 'Over'))].

		ScratchTranslator isRTL
			ifTrue:[
				b _ ResizableToggleButton2 new
					offForm:	(offForm flipBy: #horizontal centerAt: offForm center)
					onForm:		(onForm flipBy: #horizontal centerAt: onForm center)
					overForm:	(overForm flipBy: #horizontal centerAt: overForm center)]
			ifFalse:[
				b _ ResizableToggleButton2 new
					offForm:	offForm
					onForm:		onForm
					overForm:	overForm].
		b
			label: label font: (ScratchFrameMorph getFont: #Category);
			setLabelColor: Color white;
			target: self;
			actionSelector: #category:;
			arguments: (Array with: cat);
			toggleButtonMode: true;
			toggleMode: false.
		ScratchTranslator isRTL
			ifTrue:[b rightJustifyInset: 10]
			ifFalse:[b leftJustifyInset: 10].
		maxExtent _ maxExtent max: (b extent + (3 @ -6)).
		b].

	"calculate catButtonsExtent"
	pad _ 15. "padding on left, right, and betwen the button columns"
	catButtonsExtent _ ((2 * maxExtent x) + (3 * pad)) @ (((catList size // 2) * (maxExtent y + 6)) + 25).

	"place the buttons"
	leftColumnX _ self left + 12 + pad.
	rightColumnX _ leftColumnX + maxExtent x + pad.
	x _ leftColumnX.
	y _ categoryChooser top + 17.
	1 to: buttons size do: [:i |
		b _ buttons at: i.
		b extent: maxExtent.
		categoryChooser addMorph: (b position: x@y).
		i even
			ifTrue: [x _ leftColumnX. y _ y + b height + 6]
			ifFalse: [x _ rightColumnX]].

	categoryChooser width: catButtonsExtent x + 25.
	categoryChooser height: catButtonsExtent y.
! !

!BlockDialog methodsFor: 'initialization' stamp: 'jens 2/26/2010 00:43'!
buildScopeRadioButtons
	| label1 label2 |
	scopeRadioButtons _ AlignmentMorph newRow
		color: Color transparent;
		hResizing: #shrinkWrap;
		vResizing: #shrinkWrap.

	allSpritesRadioButton _ ToggleButton
		onForm: (ScratchFrameMorph skinAt: #radioButtonOn)
		offForm: (ScratchFrameMorph skinAt: #radioButton).
	allSpritesRadioButton
		on;
		target: self;
		actionSelector: #toggleSpriteSpecific.
	label1 _ StringMorph new
		contents: ('For all sprites' localized);
		font: (ScratchFrameMorph getFont: #NewVariableDialogBox).
	scopeRadioButtons addMorphBack: allSpritesRadioButton.
	scopeRadioButtons addMorphBack: (Morph new extent: (5@5); color: Color transparent).
	scopeRadioButtons addMorphBack: label1.
	scopeRadioButtons addMorphBack: (Morph new extent: (15@5); color: Color transparent).

	thisSpriteRadioButton _ allSpritesRadioButton fullCopy off.
	label2 _ StringMorph new
		contents: ('For this sprite only' localized);
		font: (ScratchFrameMorph getFont: #NewVariableDialogBox).
	scopeRadioButtons addMorphBack: thisSpriteRadioButton.
	scopeRadioButtons addMorphBack: (Morph new extent: (5@5); color: Color transparent).
	scopeRadioButtons addMorphBack: label2.

	ScratchTranslator isRTL
		ifTrue: [scopeRadioButtons submorphs reversed do: [:m |
			m delete.
			scopeRadioButtons addMorphBack: m]].

! !

!BlockDialog methodsFor: 'initialization' stamp: 'jens 1/11/2010 01:53'!
buildTypeChooser
	| spacer |

	spacer _ (Morph new extent: (5@5); color: Color transparent).

	radioButtons _ AlignmentMorph newRow
		color: Color transparent;
		hResizing: #shrinkWrap;
		vResizing: #shrinkWrap.

	commandBlockRadioButton _ ToggleButton
		onForm: self formTypeCommandOn
		offForm: self formTypeCommandOff
		overForm: self formTypeCommandOver.
	commandBlockRadioButton
		on;
		target: self;
		actionSelector: #selectCommandBlock.

	radioButtons addMorphBack: commandBlockRadioButton.
	radioButtons addMorphBack: spacer fullCopy.

	reporterBlockRadioButton _ ToggleButton
		onForm: self formTypeReporterOn
		offForm: self formTypeReporterOff
		overForm: self formTypeReporterOver.
	reporterBlockRadioButton
		off;
		target: self;
		actionSelector: #selectReporterBlock.

	radioButtons addMorphBack: reporterBlockRadioButton.
	radioButtons addMorphBack: spacer fullCopy.

	booleanBlockRadioButton _ ToggleButton
		onForm: self formTypePredicateOn
		offForm: self formTypePredicateOff
		overForm: self formTypePredicateOver.
	booleanBlockRadioButton
		off;
		target: self;
		actionSelector: #selectBooleanBlock.

	radioButtons addMorphBack: booleanBlockRadioButton.
! !

!BlockDialog methodsFor: 'initialization' stamp: 'jens 1/12/2010 11:11'!
disableAllButCategory

	mainColumn submorphsDo: [: m |
		((m = messageLineMorphs) not) ifTrue: [m delete]].
	mainColumn
		addMorphBack: (Morph new extent: (5@7); color: Color transparent);
		addMorphBack: categoryChooser;
		addMorphBack: (Morph new extent: (5@7); color: Color transparent);
		addMorphBack: buttonRow;
		addMorphBack: bottomSpacer.
! !

!BlockDialog methodsFor: 'initialization' stamp: 'jens 7/19/2010 02:14'!
disableAllButCategoryAndShape

	| keep |

	keep _ Array
				with: messageLineMorphs
				with: radioButtons.


	mainColumn submorphsDo: [: m |
		(keep includes: m)
			ifFalse: [m delete]].

	mainColumn
		addMorphBack: (Morph new extent: (5@7); color: Color transparent);
		addMorphBack: categoryChooser;
		addMorphBack: (Morph new extent: (5@7); color: Color transparent);

		addMorphBack: radioButtons;
		addMorphBack: (Morph new extent: (5@7); color: Color transparent);

		addMorphBack: buttonRow;
		addMorphBack: bottomSpacer.! !

!BlockDialog methodsFor: 'initialization' stamp: 'jens 6/28/2010 01:14'!
getUserResponse

	| newBlockSpec |
	newBlockSpec _ super getUserResponse.
	newBlockSpec size = 0 ifTrue: [^ #cancelled].
	category  = #other ifTrue: [
		category = #none ].
	^ Array with: newBlockSpec with: reporterBlockFlag with: booleanBlockFlag with: category with: spriteSpecificFlag
! !

!BlockDialog methodsFor: 'initialization' stamp: 'jens 6/28/2010 01:17'!
initialize

	super initialize.
	reporterBlockFlag _ false.
	booleanBlockFlag _ false.
	type _ #none.
	category _ #other.
	spriteSpecificFlag _ false.

	self buildTypeChooser.
	self buildCategoryChooser.
	self buildScopeRadioButtons.

	mainColumn submorphsDo: [: m |
		((m = messageLineMorphs) not) ifTrue: [m delete]].
	mainColumn
		addMorphBack: (Morph new extent: (5@6); color: Color transparent);
		addMorphBack: categoryChooser;
		addMorphBack: (Morph new extent: (5@7); color: Color transparent);
		addMorphBack: radioButtons;
		addMorphBack: (Morph new extent: (5@7); color: Color transparent);
		addMorphBack: typeinMorph;
		addMorphBack: (Morph new extent: (5@7); color: Color transparent);
		addMorphBack: scopeRadioButtons;
		addMorphBack: (Morph new extent: (5@7); color: Color transparent);
		addMorphBack: buttonRow;
		addMorphBack: bottomSpacer.

	self category: category.

! !


!BlockDialog methodsFor: 'interaction' stamp: 'jens 1/29/2010 00:43'!
category: aString

	category _ aString.

	self updateTypeSelection.

	categoryChooser submorphs do: [:m |
		(m isKindOf: ResizableToggleButton2) ifTrue: [
			m arguments first = category
				ifTrue: [m on]
				ifFalse: [m off]]].

	World activeHand newKeyboardFocus: tabFields first.
! !

!BlockDialog methodsFor: 'interaction' stamp: 'jens 1/8/2010 00:50'!
disableTypeDeclaration

	radioButtons isHidden: true! !


!BlockDialog methodsFor: 'accessing' stamp: 'jens 1/29/2010 00:42'!
setCategory: aSymbol

	#none = aSymbol ifTrue: [
		^category _ #other ].
	category _ aSymbol! !

!BlockDialog methodsFor: 'accessing' stamp: 'jens 1/7/2010 19:44'!
setType: aSymbol

	type _ aSymbol! !

!BlockDialog methodsFor: 'accessing' stamp: 'jens 1/7/2010 12:12'!
setUserSpec: aString

	userSpec _ aString! !

!BlockDialog methodsFor: 'accessing' stamp: 'jens 1/11/2010 01:42'!
updateInitialSettings

	self
		initialAnswer: userSpec;
		category: category;
		updateTypeSelection! !

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

BlockDialog class
	instanceVariableNames: ''!

!BlockDialog class methodsFor: 'instance creation' stamp: 'jens 6/22/2010 22:48'!
ask: questionString
	"Put up an instance of me to ask the user for the name for a new variable."

	| dialogBox |
	dialogBox _ self new
		withButtonsForYes: false no: false okay: true cancel: true;
		title: questionString;
		message: 'category:' localized;
		extent: 330@200.
	^ dialogBox getUserResponse
! !

!BlockDialog class methodsFor: 'instance creation' stamp: 'jens 10/13/2008 13:59'!
askWithCancel: questionString initialAnswer: aString
	"Put up an instance of me to ask the user for string input (such as file name). The initial response text is set to the given string, which the user can replace or edit. This version includes a cancel button. Answer the empty string if cancelled."

	| dialogBox |
	dialogBox _ self new
		withButtonsForYes: false no: false okay: true cancel: true;
		message: questionString;
		initialAnswer: aString.
	^ dialogBox getUserResponse
! !

!BlockDialog class methodsFor: 'instance creation' stamp: 'jens 6/11/2010 00:09'!
isOpen
	self allInstancesDo: [:bd |
		bd isInWorld ifTrue: [^true]].
	^ false! !
