StringDialog subclass: #BlockLabelFragmentDialog
	instanceVariableNames: 'fragment inputRadioButton textRadioButton slotShapeButton fragmentRadioButtons category isCollapsed slotShapesGroup groupExtent radioObject radioAny radioNumber radioText radioBoolean radioList radioCommand radioReporter radioPredicate radioLoop radioUnevaluated radioUnevaluatedBoolean defaultLabel defaultField divBar singleRadioButton multipleRadioButton externalizedRadioButton '
	classVariableNames: 'Expanded '
	poolDictionaries: ''
	category: 'Scratch-BYOB'!

!BlockLabelFragmentDialog methodsFor: 'private' stamp: 'jens 1/19/2010 01:39'!
extent: aPoint
	
	bounds extent = aPoint ifFalse: [
		self changed.
		bounds _ bounds topLeft extent: aPoint.
		self layoutChanged.
		self changed].

	self fixLayoutForExtent: aPoint.

"	UserPos isNil & resizeOffset isNil ifTrue: [
		w _ self world.
		w ifNotNil: [self position: w center - (self extent // 2)]]."  "center on screen"
! !

!BlockLabelFragmentDialog methodsFor: 'private' stamp: 'jens 3/5/2010 01:01'!
shouldBeExpanded
	^self class isExpanded! !


!BlockLabelFragmentDialog methodsFor: 'initialization' stamp: 'jens 2/14/2011 02:03'!
buildSlotTypeChoices
	 | lineObject lineAny lineNumber lineText lineBoolean lineList lineCommand lineReporter linePredicate lineLoop lineUnevaluated lineUnevaluatedBoolean
	picture label typeChooser picSize lineWidth typeLabel typeFont bg titleClr labelClr labelSingle
	labelMultiple labelExternalized temp onForm offForm|

	onForm _  ScratchFrameMorph skinAt: #radioButtonOn.
	offForm _ ScratchFrameMorph skinAt: #radioButton.
"
	onForm _  ScratchFrameMorph skinAt: #watcherButtonPressed.
	offForm _ ScratchFrameMorph skinAt: #watcherButton.
"
	picSize _ 45@25.
	lineWidth _ 155 "125".
	titleClr _ Color gray muchLighter.
	labelClr _ Color white.

	typeChooser _ ImageFrameMorph new.
	bg _ (ScratchFrameMorph skinAt:  #paintOptionsBackground) deepCopy.
	bg replaceColor: (bg colorAt: bg center) with: ScratchFrameMorph palettePaneColor.
	typeChooser initFromForm: bg.
	typeChooser extent: (lineWidth + 20) * 3 @ (picSize y * 9).

	typeFont _ ScratchFrameMorph getFont: #FilePickerEntry.

	typeLabel _ ((StringMorph contents: 'Input type/Shape of slot:' localized font: (ScratchFrameMorph getFont: #Label))
		color: titleClr;
		position: typeChooser position + (15@14);
		yourself).

	typeChooser addMorph: typeLabel.

"+++++++++++  object ++++++++++++++++"

	radioObject _ ToggleButton
		onForm: onForm
		offForm: offForm.
	radioObject
		off;
		target: self;
		actionSelector: #typeObject;
		top: 6.
	picture _ ImageMorph new form: (self slotShapeFormFor: #object size: picSize).
	label _ (StringMorph contents: 'Object' localized font: typeFont)
		color: labelClr.
	lineObject _ Morph new color: Color transparent.
	lineObject extent: lineWidth @ picSize y.
	picture left: radioObject right.
	label left: picture right; top: 4.
	lineObject
		addMorph: radioObject;
		addMorph: picture;
		addMorph: label.
	lineObject position: typeLabel bottomLeft + (0@10).
	typeChooser addMorph: lineObject.	

"+++++++++++  number ++++++++++++++++"

	radioNumber _ ToggleButton
		onForm: onForm
		offForm: offForm.
	radioNumber
		off;
		target: self;
		actionSelector: #typeNumber;
		top: 6.
	picture _ ImageMorph new form: (self slotShapeFormFor: #number size: picSize).
	label _ (StringMorph contents: 'Number' localized font: typeFont)
		color: labelClr.
	lineNumber _ Morph new color: Color transparent.
	lineNumber extent: lineWidth @ picSize y.
	picture left: radioNumber right.
	label left: picture right; top: 4.
	lineNumber
		addMorph: radioNumber;
		addMorph: picture;
		addMorph: label.
	lineNumber position: lineObject bottomLeft.
	typeChooser addMorph: lineNumber.	

"++++++++++++++  text  +++++++++++++"

	radioText _ ToggleButton
		onForm: onForm
		offForm: offForm.
	radioText
		off;
		target: self;
		actionSelector: #typeText;
		top: 6.
	picture _ ImageMorph new form: (self slotShapeFormFor: #text size: picSize).
	label _ (StringMorph contents: 'Text' localized font: typeFont)
		color: labelClr.
	lineText _ Morph new color: Color transparent.
	lineText extent: lineWidth @ picSize y.
	picture left: radioText right.
	label left: picture right; top: 4.
	lineText
		addMorph: radioText;
		addMorph: picture;
		addMorph: label. 
	lineText position: lineObject topRight + (10@0).
	typeChooser addMorph: lineText.	

"++++++++++++  list  +++++++++++++++"

	radioList _ ToggleButton
		onForm: onForm
		offForm: offForm.
	radioList
		off;
		target: self;
		actionSelector: #typeList;
		top: 6.
	picture _ ImageMorph new form: (self slotShapeFormFor: #list size: picSize).
	label _ (StringMorph contents: 'List' localized font: typeFont)
		color: labelClr.
	lineList _ Morph new color: Color transparent.
	lineList extent: lineWidth @ picSize y.
	picture left: radioList right.
	label left: picture right; top: 4.
	lineList
		addMorph: radioList;
		addMorph: picture;
		addMorph: label. 
	lineList position: lineText topRight + (10@0).
	typeChooser addMorph: lineList.	

"++++++++++++  any  +++++++++++++++"
	
	radioAny _ ToggleButton
		onForm: onForm
		offForm: offForm.
	radioAny
		off;
		target: self;
		actionSelector: #typeAny; 
		top: 6.
	picture _ ImageMorph new form: (self slotShapeFormFor: #any size: picSize).
	label _ (StringMorph contents: 'Any type' localized font: typeFont)
		color: labelClr.
	lineAny _ Morph new color: Color transparent.
	lineAny extent: lineWidth @ picSize y.
	picture left: radioAny right.
	label left: picture right; top: 4.
	lineAny
		addMorph: radioAny;
		addMorph: picture;
		addMorph: label. 
	lineAny position: lineText bottomLeft.
	typeChooser addMorph: lineAny.	

"++++++++++++  bool  +++++++++++++++"

	radioBoolean _ ToggleButton
		onForm: onForm
		offForm: offForm.
	radioBoolean
		off;
		target: self;
		actionSelector: #typeBoolean;
		top: 6.
	picture _ ImageMorph new form: (self slotShapeFormFor: #boolean size: picSize).
	label _ (StringMorph contents: 'Boolean (T/F)' localized font: typeFont)
		color: labelClr.
	lineBoolean _ Morph new color: Color transparent.
	lineBoolean extent: lineWidth @ picSize y.
	picture left: radioBoolean right.
	label left: picture right; top: 4.
	lineBoolean
		addMorph: radioBoolean;
		addMorph: picture;
		addMorph: label. 
	lineBoolean position: lineList bottomLeft.
	typeChooser addMorph: lineBoolean.	

"++++++++++++  command  +++++++++++++++"

	radioCommand _ ToggleButton
		onForm: onForm
		offForm: offForm.
	radioCommand
		off;
		target: self;
		actionSelector: #typeCommand;
		top: 6.
	picture _ ImageMorph new form: (self slotShapeFormFor: #command size: picSize).
	label _ (StringMorph contents: 'Command (inline)' localized font: typeFont)
		color: labelClr.
	lineCommand _ Morph new color: Color transparent.
	lineCommand extent: lineWidth @ picSize y.
	picture left: radioCommand right.
	label left: picture right; top: 4.
	lineCommand
		addMorph: radioCommand;
		addMorph: picture;
		addMorph: label. 
	lineCommand position: lineNumber left @ lineAny bottom.
	typeChooser addMorph: lineCommand.	

"+++++++++++  reporter  ++++++++++++++++"

	radioReporter _ ToggleButton
		onForm: onForm
		offForm: offForm.
	radioReporter
		off;
		target: self;
		actionSelector: #typeReporter;
		top: 6.
	picture _ ImageMorph new form: (self slotShapeFormFor: #reporter size: picSize).
	label _ (StringMorph contents: 'Reporter' localized font: typeFont)
		color: labelClr.
	lineReporter _ Morph new color: Color transparent.
	lineReporter extent: lineWidth @ picSize y.
	picture left: radioReporter right.
	label left: picture right; top: 4.
	lineReporter
		addMorph: radioReporter;
		addMorph: picture;
		addMorph: label. 
	lineReporter position: lineAny bottomLeft.
	typeChooser addMorph: lineReporter.	

"+++++++++++  predicate  ++++++++++++++++"

	radioPredicate _ ToggleButton
		onForm: onForm
		offForm: offForm.
	radioPredicate
		off;
		target: self;
		actionSelector: #typePredicate;
		top: 6.
	picture _ ImageMorph new form: (self slotShapeFormFor: #predicate size: picSize).
	label _ (StringMorph contents: 'Predicate' "(Reporter of Boolean)" localized font: typeFont)
		color: labelClr.
	linePredicate _ Morph new color: Color transparent.
	linePredicate extent: lineWidth @ picSize y.
	picture left: radioPredicate right.
	label left: picture right; top: 4.
	linePredicate
		addMorph: radioPredicate;
		addMorph: picture;
		addMorph: label. 
	linePredicate position:  lineBoolean bottomLeft. 
	typeChooser addMorph: linePredicate.

"+++++++++++++  command (C-shape)  ++++++++++++++"

	radioLoop _ ToggleButton
		onForm: onForm
		offForm: offForm.
	radioLoop
		off;
		target: self;
		actionSelector: #typeLoop;
		top: 6.
	picture _ ImageMorph new form: (self slotShapeFormFor: #loop size: picSize).
	label _ (StringMorph contents: 'C-shape' localized font: typeFont)
		color: labelClr.
	lineLoop _ Morph new color: Color transparent.
	lineLoop extent: lineWidth @ picSize y.
	picture left: radioLoop right.
	label left: picture right; top: 4.
	lineLoop
		addMorph: radioLoop;
		addMorph: picture;
		addMorph: label. 
	lineLoop position: lineCommand bottomLeft.
	typeChooser addMorph: lineLoop.

"++++++++++++++  any (unevaluated)  +++++++++++++"

	radioUnevaluated _ ToggleButton
		onForm: onForm
		offForm: offForm.
	radioUnevaluated
		off;
		target: self;
		actionSelector: #typeUnevaluated;
		top: 6.
	picture _ ImageMorph new form: (self slotShapeFormFor: #unevaluated size: picSize).
	label _ (StringMorph contents: 'Any (unevaluated)' localized font: typeFont)
		color: labelClr.
	lineUnevaluated _ Morph new color: Color transparent.
	lineUnevaluated extent: lineWidth @ picSize y.
	picture left: radioUnevaluated right.
	label left: picture right; top: 4.
	lineUnevaluated
		addMorph: radioUnevaluated;
		addMorph: picture;
		addMorph: label. 
	lineUnevaluated position: lineReporter bottomLeft.
	typeChooser addMorph: lineUnevaluated.	

"++++++++++++++  boolean (unevaluated)  +++++++++++++"

	radioUnevaluatedBoolean _ ToggleButton
		onForm: onForm
		offForm: offForm.
	radioUnevaluatedBoolean
		off;
		target: self;
		actionSelector: #typeUnevaluatedBoolean;
		top: 6.
	picture _ ImageMorph new form: (self slotShapeFormFor: #unevaluatedBoolean size: picSize).
	label _ (StringMorph contents: 'Boolean (unevaluated)' localized font: typeFont)
		color: labelClr.
	lineUnevaluatedBoolean _ Morph new color: Color transparent.
	lineUnevaluatedBoolean extent: lineWidth @ picSize y.
	picture left: radioUnevaluatedBoolean right.
	label left: picture right; top: 4.
	lineUnevaluatedBoolean
		addMorph: radioUnevaluatedBoolean;
		addMorph: picture;
		addMorph: label. 
	lineUnevaluatedBoolean position: linePredicate bottomLeft.
	typeChooser addMorph: lineUnevaluatedBoolean.	

"+++++++++++++++++++++++++++"

	divBar _ ImageMorph new form: (ScratchFrameMorph skinAt: #connector).
	divBar 
		top: lineLoop bottom + 5;
		left: "lineReporter left "typeChooser left + (typeChooser width - (divBar width * 3) // 3).
	typeChooser addMorph: divBar.

	temp _ divBar deepCopy.
	temp position: divBar topRight.
	typeChooser addMorph: temp.

	temp _ divBar deepCopy.
	temp position: divBar topRight + (temp width @ 0).
	typeChooser addMorph: temp.


	singleRadioButton _ ToggleButton
		onForm: (ScratchFrameMorph skinAt: #radioButtonOn)
		offForm: (ScratchFrameMorph skinAt: #radioButton).
	singleRadioButton
		on;
		target: self;
		actionSelector: #aritySingle;
		position: lineLoop left @ (divBar bottom + 9).
	typeChooser addMorph: singleRadioButton.	

	labelSingle _ ((StringMorph contents: 'Single input.' localized font: (ScratchFrameMorph getFont: #Label))
		color: titleClr;
		position: singleRadioButton topRight + (4@0);
		yourself).
	typeChooser addMorph: labelSingle.

	defaultLabel _ ((StringMorph contents: 'Default value:' localized font: (ScratchFrameMorph getFont: #Label))
		color: titleClr;
		position: labelSingle topRight + (10@0);
		yourself).
	typeChooser addMorph: defaultLabel.

	typeChooser
		addMorph: (defaultField _ StringFieldMorph
			new client: self;
			borderWidth: 2;
			color: "Color lightGray twiceLighter "(Color r: (211/255) g: (214/255) b: (216/255))).
	defaultField
		font: typeFont;
		width: lineWidth;
		position: defaultLabel topRight + (10@-4);
		isNumeric: fragment default isNumber;
		contents: fragment default asString.

	groupExtent _ typeChooser extent.
	slotShapesGroup _ typeChooser.

	multipleRadioButton _ ToggleButton
		onForm: (ScratchFrameMorph skinAt: #radioButtonOn)
		offForm: (ScratchFrameMorph skinAt: #radioButton).
	multipleRadioButton
		off;
		target: self;
		actionSelector: #arityMultiple;
		position: singleRadioButton bottomLeft + (0@6).
	typeChooser addMorph: multipleRadioButton.	

	labelMultiple _ ((StringMorph contents: 'Multiple inputs (value is list of inputs)' localized font: (ScratchFrameMorph getFont: #Label))
		color: titleClr;
		position: multipleRadioButton topRight + (4@0);
		yourself).
	typeChooser addMorph: labelMultiple.

	externalizedRadioButton _ ToggleButton
		onForm: (ScratchFrameMorph skinAt: #radioButtonOn)
		offForm: (ScratchFrameMorph skinAt: #radioButton).
	externalizedRadioButton
		off;
		target: self;
		actionSelector: #externalized;
		position: multipleRadioButton bottomLeft + (0@6).
	typeChooser addMorph: externalizedRadioButton.	

	labelExternalized _ ((StringMorph contents: 'Make internal variable visible to caller' localized font: (ScratchFrameMorph getFont: #Label))
		color: titleClr;
		position: externalizedRadioButton topRight + (4@0);
		yourself).
	typeChooser addMorph: labelExternalized.

! !

!BlockLabelFragmentDialog methodsFor: 'initialization' stamp: 'jens 1/21/2010 01:29'!
buildWidgets


	| titleLabel inputLabel |
	fragmentRadioButtons _ AlignmentMorph newRow
		color: Color transparent;
		hResizing: #shrinkWrap;
		vResizing: #shrinkWrap.

	textRadioButton _ ToggleButton
		onForm: (ScratchFrameMorph skinAt: #radioButtonOn)
		offForm: (ScratchFrameMorph skinAt: #radioButton).
	textRadioButton
		on;
		target: self;
		actionSelector: #toggleIsInput.

	titleLabel _ ImageMorph new form: self labelButtonForm.
	fragmentRadioButtons addMorphBack: textRadioButton.
	fragmentRadioButtons addMorphBack: (Morph new extent: (5@5); color: Color transparent).
	fragmentRadioButtons addMorphBack: titleLabel.
	fragmentRadioButtons addMorphBack: (Morph new extent: (15@5); color: Color transparent).

	inputRadioButton _ textRadioButton fullCopy off.
	inputLabel _ ImageMorph new form: self inputButtonForm.
	fragmentRadioButtons addMorphBack: inputRadioButton.
	fragmentRadioButtons addMorphBack: (Morph new extent: (5@5); color: Color transparent).
	fragmentRadioButtons addMorphBack: inputLabel "label2".


	fragmentRadioButtons addMorphBack: (Morph new extent: (15@5); color: Color transparent).

	slotShapeButton _ IconicButton new
		labelGraphic: (ScratchFrameMorph skinAt: #arrowOpenComment) borderWidth: 0;
		actionSelector: #toggleExpand;
		target: self;
		actWhen: #buttonDown.
	fragmentRadioButtons addMorphBack: slotShapeButton.

	self buildSlotTypeChoices.

	mainColumn submorphsDo: [: m |
		((m = messageLineMorphs) not) ifTrue: [m delete]].
	mainColumn
		addMorphBack: (Morph new extent: (5@6); color: Color transparent);
		addMorphBack: typeinMorph;
		addMorphBack: (Morph new extent: (5@7); color: Color transparent);
		addMorphBack: fragmentRadioButtons;
		addMorphBack: (Morph new extent: (5@7); color: Color transparent);
		addMorphBack: slotShapesGroup;
		addMorphBack: (Morph new extent: (5@7); color: Color transparent);
		addMorphBack: buttonRow;
		addMorphBack: bottomSpacer.

! !

!BlockLabelFragmentDialog methodsFor: 'initialization' stamp: 'jens 1/19/2010 01:45'!
initialize

	super initialize.
	category _ #none.
	isCollapsed _ false


! !

!BlockLabelFragmentDialog methodsFor: 'initialization' stamp: 'jens 2/15/2010 03:40'!
refresh

	self
		setInitialValues;
		updateInputRadioButtons;
		updateArity;
		updateSlotShape;
		withButtonsForYes: false no: false okay: true delete: (fragment label size > 0) cancel: true! !

!BlockLabelFragmentDialog methodsFor: 'initialization' stamp: 'jens 6/7/2010 23:18'!
setInitialValues

	fragment isInput 
		ifTrue: [ 
			fragment label isEmpty
				ifTrue: [ self message: 'Create input name' localized]
				ifFalse: [ self message: 'Edit input name' localized].
			self initialAnswer: (UTF8 withAll: fragment label asMacRoman)]
		ifFalse: [ 
			fragment label isEmpty
				ifTrue: [ self message: 'Create label fragment' localized]
				ifFalse: [ self message: 'Edit label fragment' localized].
			self initialAnswer: fragment label]
! !


!BlockLabelFragmentDialog methodsFor: 'interaction' stamp: 'jens 7/20/2010 22:52'!
acceptDefaultValue

	| cnts |

	(#(any number text unevaluated) includes: fragment type) 
		ifFalse: [ 
			fragment default: ''. 
			^ self].
		
	#number = fragment type 
		ifTrue: [
			cnts _ defaultField contents.
			cnts = ' ' asUTF8
				ifTrue: [ fragment default: cnts ]
				ifFalse: [ fragment default: cnts asNumberNoError ]]
		ifFalse: [fragment default: defaultField contents asString ]
! !

!BlockLabelFragmentDialog methodsFor: 'interaction' stamp: 'jens 3/9/2010 22:35'!
arityMultiple

	singleRadioButton off.
	multipleRadioButton on.
	externalizedRadioButton off.
	self updateSlotShape
! !

!BlockLabelFragmentDialog methodsFor: 'interaction' stamp: 'jens 3/9/2010 22:35'!
aritySingle

	singleRadioButton on.
	multipleRadioButton off.
	externalizedRadioButton off.
	self updateSlotShape
! !

!BlockLabelFragmentDialog methodsFor: 'interaction' stamp: 'jens 1/12/2010 05:08'!
deleteItem
	"Delete button was pressed."

	fragment delete.
	response _ fragment.
	done _ true.
	self delete.
	World doOneCycle.  "erase myself from the screen"
! !

!BlockLabelFragmentDialog methodsFor: 'interaction' stamp: 'jens 3/9/2010 22:35'!
externalized

	singleRadioButton off.
	multipleRadioButton off.
	externalizedRadioButton on.
	self updateSlotShape
! !

!BlockLabelFragmentDialog methodsFor: 'interaction' stamp: 'jens 3/5/2010 01:38'!
getUserResponse

	| txt |
	txt _ super getUserResponse.
	txt size = 0 ifTrue: [^ #cancelled].
	self acceptDefaultValue.
	self class isExpanded: isCollapsed not.
	^ fragment label: txt; yourself
! !

!BlockLabelFragmentDialog methodsFor: 'interaction' stamp: 'jens 4/27/2010 18:09'!
toggleExpand

	isCollapsed _ isCollapsed not.

	isCollapsed
		ifTrue: [slotShapeButton labelGraphic: (ScratchFrameMorph skinAt: #arrowClosedComment) ]
		ifFalse: [slotShapeButton labelGraphic: (ScratchFrameMorph skinAt: #arrowOpenComment)].

	mainColumn submorphsDo: [: m |
		((m = messageLineMorphs) not) ifTrue: [m delete]].

	isCollapsed
		ifTrue: [ mainColumn
			addMorphBack: (Morph new extent: (5@6); color: Color transparent);
			addMorphBack: typeinMorph;
			addMorphBack: (Morph new extent: (5@7); color: Color transparent);
			addMorphBack: fragmentRadioButtons;
			addMorphBack: (Morph new extent: (5@7); color: Color transparent);
			addMorphBack: buttonRow;
			addMorphBack: bottomSpacer]
		ifFalse: [ mainColumn
			addMorphBack: (Morph new extent: (5@6); color: Color transparent);
			addMorphBack: typeinMorph;
			addMorphBack: (Morph new extent: (5@7); color: Color transparent);
			addMorphBack: fragmentRadioButtons;
			addMorphBack: (Morph new extent: (5@7); color: Color transparent);
			addMorphBack: slotShapesGroup;
			addMorphBack: (Morph new extent: (5@7); color: Color transparent);
			addMorphBack: buttonRow;
			addMorphBack: bottomSpacer].

	self extent: mainColumn fullBounds extent + (60@50).

	fragment isInput ifTrue: [self class isExpanded: isCollapsed not].
! !

!BlockLabelFragmentDialog methodsFor: 'interaction' stamp: 'jens 1/20/2010 02:46'!
toggleExpandIfInput

	self toggleExpand.
	fragment isInput ifFalse: [
		self toggleExpand ]! !

!BlockLabelFragmentDialog methodsFor: 'interaction' stamp: 'jens 1/20/2010 13:49'!
toggleIsInput

	fragment isInput: fragment isInput not.
	self updateInputRadioButtons

! !

!BlockLabelFragmentDialog methodsFor: 'interaction' stamp: 'jens 1/19/2010 23:11'!
typeAny
	fragment type: #any.
	self updateSlotShape
! !

!BlockLabelFragmentDialog methodsFor: 'interaction' stamp: 'jens 1/19/2010 23:12'!
typeBoolean
	fragment type: #boolean.
	self updateSlotShape
! !

!BlockLabelFragmentDialog methodsFor: 'interaction' stamp: 'jens 1/19/2010 23:13'!
typeCommand
	fragment type: #command.
	self updateSlotShape
! !

!BlockLabelFragmentDialog methodsFor: 'interaction' stamp: 'jens 1/19/2010 23:12'!
typeList
	fragment type: #list.
	self updateSlotShape
! !

!BlockLabelFragmentDialog methodsFor: 'interaction' stamp: 'jens 4/11/2010 23:14'!
typeLoop
	fragment type: #loop.
	self updateSlotShape
! !

!BlockLabelFragmentDialog methodsFor: 'interaction' stamp: 'jens 1/19/2010 23:11'!
typeNumber
	fragment type: #number.
	self updateSlotShape
! !

!BlockLabelFragmentDialog methodsFor: 'interaction' stamp: 'jens 2/14/2011 02:05'!
typeObject
	fragment type: #object.
	self updateSlotShape
! !

!BlockLabelFragmentDialog methodsFor: 'interaction' stamp: 'jens 1/19/2010 23:13'!
typePredicate
	fragment type: #predicate.
	self updateSlotShape
! !

!BlockLabelFragmentDialog methodsFor: 'interaction' stamp: 'jens 7/5/2010 22:54'!
typeReporter
	fragment type: #reporter.
	self updateSlotShape
! !

!BlockLabelFragmentDialog methodsFor: 'interaction' stamp: 'jens 7/5/2010 22:53'!
typeReporterSlot
	fragment type: #reporterSlot.
	self updateSlotShape
! !

!BlockLabelFragmentDialog methodsFor: 'interaction' stamp: 'jens 1/19/2010 23:12'!
typeText
	fragment type: #text.
	self updateSlotShape
! !

!BlockLabelFragmentDialog methodsFor: 'interaction' stamp: 'jens 7/8/2010 22:04'!
typeTypeInReporter
	fragment type: #typeInReporter.
	self updateSlotShape
! !

!BlockLabelFragmentDialog methodsFor: 'interaction' stamp: 'jens 7/20/2010 22:20'!
typeUnevaluated
	fragment type: #unevaluated.
	self updateSlotShape
! !

!BlockLabelFragmentDialog methodsFor: 'interaction' stamp: 'jens 7/23/2010 01:01'!
typeUnevaluatedBoolean
	fragment type: #unevaluatedBoolean.
	self updateSlotShape
! !

!BlockLabelFragmentDialog methodsFor: 'interaction' stamp: 'jens 3/9/2010 23:19'!
updateArity

	fragment type = #template
		ifTrue: [
			singleRadioButton off.
			multipleRadioButton off.
			externalizedRadioButton on.
			^ self].

	(fragment type endsWith: 'List')
		ifTrue: [
			multipleRadioButton on.
			singleRadioButton off.
			externalizedRadioButton off]
		ifFalse: [
			singleRadioButton on.
			multipleRadioButton off.
			externalizedRadioButton off]
! !

!BlockLabelFragmentDialog methodsFor: 'interaction' stamp: 'jens 7/20/2010 22:21'!
updateDefaultValue

	| dat |

	(#(any number text unevaluated) includes: fragment type)
		ifFalse: [
			(Array with: defaultLabel with: defaultField) do: [:m |
				m isHidden: true ].
			^ self ].

	dat _ defaultField contents.

	{defaultLabel. defaultField} do: [:m |
		m isHidden: false ].

	#number = fragment type ifTrue: [
		defaultField isNumeric: true.
		(dat = ' ' asUTF8 or: [dat = '' asUTF8])
			ifTrue: [ defaultField contents: ' ' asUTF8 ]
			ifFalse: [ defaultField contents: dat asNumberNoError printString].
		^ self ].

	defaultField
		isNumeric: false.
! !

!BlockLabelFragmentDialog methodsFor: 'interaction' stamp: 'jens 4/27/2010 18:16'!
updateInputRadioButtons

	fragment isInput 
		ifTrue: [
			inputRadioButton on.
			textRadioButton off.
			slotShapeButton
				isHidden: false;
				isLocked: false.
			self shouldBeExpanded
				ifTrue: [self toggleExpand]]
		ifFalse: [
			textRadioButton on.
			inputRadioButton off.
			slotShapeButton
				isHidden: true;
				lock.
			isCollapsed ifFalse: [
				self toggleExpand]]! !

!BlockLabelFragmentDialog methodsFor: 'interaction' stamp: 'jens 2/14/2011 02:06'!
updateSlotShape

	| type types |

	singleRadioButton isOn ifTrue: [
		fragment type = #template ifTrue: [
			fragment type: #any].
		(fragment type endsWith: 'List') ifTrue: [
			fragment type: (fragment type copyFrom: 1 to: fragment type size - 'List' size) asSymbol]].

	multipleRadioButton isOn ifTrue: [
		fragment type = #template ifTrue: [
			fragment type: #any].
		(fragment type endsWith: 'List') ifFalse: [
			fragment type: (fragment type, 'List') asSymbol]].

	externalizedRadioButton isOn ifTrue: [
		fragment type: #template ].

	types _ Dictionary new.
	types
		at: #any put: radioAny;
		at: #number put: radioNumber;
		at: #text put: radioText;
		at: #boolean put: radioBoolean;
		at: #list put: radioList;
		at: #command put: radioCommand;
		at: #reporter put: radioReporter;
		at: #predicate put: radioPredicate;
		at: #loop put: radioLoop;
		at: #template put: radioAny;
		at: #unevaluated put: radioUnevaluated;
		at: #unevaluatedBoolean put: radioUnevaluatedBoolean;
		at: #object put: radioObject.

	types
		at: #anyList put: radioAny;
		at: #numberList put: radioNumber;
		at: #textList put: radioText;
		at: #booleanList put: radioBoolean;
		at: #listList put: radioList;
		at: #commandList put: radioCommand;
		at: #reporterList put: radioReporter;
		at: #predicateList put: radioPredicate;
		at: #loopList put: radioLoop;
		at: #unevaluatedList put: radioUnevaluated;
		at: #unevaluatedBooleanList put: radioUnevaluatedBoolean;
		at: #objectList put: radioObject.

	type _ fragment type.

	types keysDo: [:key |
		(types at: key) isHidden: true; off].

	types keysDo: [:key |
		#template = type ifFalse: [
			(types at: key) isHidden: false].
		type = key
			ifTrue: [(types at: key) on]].

	self updateDefaultValue! !


!BlockLabelFragmentDialog methodsFor: 'accessing' stamp: 'jens 1/17/2010 20:55'!
category: aSymbol
	category _ aSymbol! !

!BlockLabelFragmentDialog methodsFor: 'accessing' stamp: 'jens 1/12/2010 03:13'!
fragment: aBlockLabelFragment
	fragment _ aBlockLabelFragment! !


!BlockLabelFragmentDialog methodsFor: 'drawing' stamp: 'jens 8/2/2010 21:50'!
inputButtonForm
	| bg block |
	block _ VariableBlockMorph new commandSpec: 'Input name' localized; color: (ScriptableScratchMorph blockColorFor: 'variables').
	bg _ LabelFragmentBlockMorph new commandSpec: '%i'; color: (ScriptableScratchMorph blockColorFor: category asString).
	bg replaceArgMorph: bg argMorphs first by: block.
	^bg imageForm! !

!BlockLabelFragmentDialog methodsFor: 'drawing' stamp: 'jens 5/17/2010 01:47'!
labelButtonForm

	| block |

	block _ LabelFragmentBlockMorph new 
		color: (ScriptableScratchMorph blockColorFor: category asString);
		commandSpec: 'Title text' localized.

	^block imageForm
! !

!BlockLabelFragmentDialog methodsFor: 'drawing' stamp: 'JM 8/3/2011 16:49'!
slotShapeFormFor: type size: aPoint

	| specs block slot morph img |

	specs _ Dictionary new.
	specs
		at: #command put: '%o';
		at: #loop put: '%G';
		at: #unevaluated put: '%j';
		at: #reporter put: '%r';
		at: #predicate put: '%6';
		at: #list put: '%t';
		at: #text put: '%T';
		at: #any put: '%s';
		at: #boolean put: '%b';
		at: #number put: '%n';
		at: #unevaluatedBoolean put: '%Q';
		at: #object put: '%1'.

	block _ LabelFragmentBlockMorph new
		color: (ScriptableScratchMorph blockColorFor: category asString); 
		commandSpec: '_', (specs at: type), '_'.

	(#(predicate boolean unevaluatedBoolean reporter typeInReporter command text loop reporterSlot) includes: type) ifTrue: [
		block commandSpec: (specs at: type)].

	slot _ block argMorphs first.
	#number = type ifTrue: [
		slot numExpression: ''].	

	block fixBlockLayout.
	img _ ImageMorph new form: block imageForm.

	morph _ Morph new color: Color transparent; extent: aPoint.
	morph addMorph: img.
	img position: morph position + (morph extent - img extent // 2).
	^ morph imageForm
! !

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

BlockLabelFragmentDialog class
	instanceVariableNames: ''!

!BlockLabelFragmentDialog class methodsFor: 'instance creation' stamp: 'jens 2/25/2010 23:05'!
on: aBlockLabelFragment category: aSymbol
	"Put up an instance of me to ask the user for the name for a new variable."

	| dialogBox |
	(World allMorphs detect: [:m | m isKindOf: self] ifNone: [nil])
		ifNotNil: [^self].
	dialogBox _ self new
		category: aSymbol;
		fragment: aBlockLabelFragment;
		buildWidgets;
		refresh;
		toggleExpandIfInput.
	^ dialogBox getUserResponse
! !


!BlockLabelFragmentDialog class methodsFor: 'accessing' stamp: 'jens 3/17/2010 22:32'!
isExpanded
	"currently disabled - commented out, -jens"

	^ false "Expanded"! !

!BlockLabelFragmentDialog class methodsFor: 'accessing' stamp: 'jens 3/5/2010 01:01'!
isExpanded: bool
	Expanded _ bool! !


!BlockLabelFragmentDialog class methodsFor: 'class initialization' stamp: 'jens 3/5/2010 01:05'!
initialize
	Expanded _ false! !


BlockLabelFragmentDialog initialize!
