ChoiceArgMorph subclass: #ChoiceArgMorphForPeripheral
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Scratch-Blocks'!

!ChoiceArgMorphForPeripheral methodsFor: 'accessing' stamp: 'CWB 12/16/2010 11:45'!
options
	"Answer my set of options. If getOptionsSelector is not nil, ask the EnchantingDeviceConfiguration for a list of options."

	| device  |

	device _ ScriptableScratchMorph blockSpecSource.

	(getOptionsSelector notNil and: [device notNil]) ifTrue: [ 
		^ device perform: getOptionsSelector with: owner.
	].

	self error: 'Could not query device configuration.'.

	^ options
! !

!ChoiceArgMorphForPeripheral methodsFor: 'accessing' stamp: 'CWB 9/28/2011 20:34'!
peripheral
"Returns the peripheral named in this argument morph, or nil.  
It only makes sense to call this for a %P parameter -- one that shows the name of a peripheral!!"

	| device |

	device _ ScriptableScratchMorph blockSpecSource.
	device ifNil: [ self error: 'No device is configured.' ].

	^ device peripheralNamed: choice.
! !


!ChoiceArgMorphForPeripheral methodsFor: 'other' stamp: 'CWB 9/28/2011 20:35'!
exportArgWith: anExporter havingSpec: aSpec
	"Exports the given argument"

	| type |

	"What sort of variable are we dealing with?"
	type _ aSpec second.	"%n2 -> $n, a number type"

	"If it is a peripheral name, provide a substitution instead of a translation."
	(type = $P) ifTrue: [
		| peripheral varName |

		peripheral _ self peripheral.
		peripheral ifNil: [ 
			^ self error: 'Unable to properly export code due to unknown peripheral "', 
			choice, ' appearing in the code.' 
		].
		varName _ peripheral variableName.
	 	^ anExporter codeStream nextPutAll: varName. 
	].

	^ super exportArgWith: anExporter havingSpec: aSpec.
! !

!ChoiceArgMorphForPeripheral methodsFor: 'other' stamp: 'CWB 1/1/2011 20:02'!
fixArgLayout
	"Set my color to my owner's color, unless my setting is invalid."

	(self choice = self class invalidContents) ifTrue: [
		self color: self class invalidColor.
	] ifFalse: [ 
		super fixArgLayout.
	].

! !

!ChoiceArgMorphForPeripheral methodsFor: 'other' stamp: 'CWB 11/17/2012 20:48'!
placedInViewer
"The block has now been fully created within a ScratchViewer block palette."

	"Choose the first element in the list if no reasonable default has been specified"
	self indexOfChoice ifNil: [ self choice: self options first ].! !

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

ChoiceArgMorphForPeripheral class
	instanceVariableNames: ''!

!ChoiceArgMorphForPeripheral class methodsFor: 'invalid data' stamp: 'CWB 1/1/2011 20:07'!
invalidColor
"A color to use when this object is not in a valid state"

	^ Color r: 0.831 g: 0.156 b: 0.156.	"Standard Scratch error color"! !

!ChoiceArgMorphForPeripheral class methodsFor: 'invalid data' stamp: 'CWB 1/1/2011 19:31'!
invalidContents
"A string that represents that this morph is not in a valid state."

	^ '?'! !
