ReporterScriptBlockMorph subclass: #CommandScriptBlockMorph
	instanceVariableNames: 'nestedBlock topBarBottom blockBottom stretchHeight '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Scratch-BYOB'!

!CommandScriptBlockMorph methodsFor: 'drawing' stamp: 'jens 10/30/2009 01:40'!
canBecomeWatcher
	^false
! !

!CommandScriptBlockMorph methodsFor: 'drawing' stamp: 'jens 10/29/2009 23:31'!
drawBottomBarOn: aCanvas 

	| left barTop barBottom |

	barBottom _ self bottom - 3.
	self drawSmoothBottomEdgeOn: aCanvas.

	barTop _ barBottom - (CBlockBracketThickness - 3).
	left _ self left + CBlockBracketThickness - 1.

	aCanvas fillRectangle: (left@(barTop - 2) extent: 1@1) color: color.
	aCanvas fillRectangle: (left@(barTop - 1) extent: 2@1) color: color.
	aCanvas fillRectangle: (left@barTop extent: 3@1) color: color.

	aCanvas
		fillRectangle: ((left + 3)@barTop corner: (self right - 2)@(barTop + 1))
		color: highlightColor1.
	aCanvas
		fillRectangle: (self left@(barTop + 1) corner: (self right - 1)@barBottom)
		color: color.
	aCanvas
		fillRectangle: ((self right - 1)@(barTop + 2) corner: self right@barBottom)
		color: shadowColor.
! !

!CommandScriptBlockMorph methodsFor: 'drawing' stamp: 'jens 10/29/2009 22:58'!
drawInnerTopY: y on: aCanvas

	| left right gapStart gapEnd |
	left _ CBlockBracketThickness - 1.
	right _ self width - 1.
	gapStart _ left + PuzzleInset + 1.
	gapEnd _ gapStart + PuzzleWidth.

	self drawHLineFrom: left to: (right - 1) y: y color: color on: aCanvas.
	self drawHLineFrom: left to: (right - 2) y: y + 1 color: color on: aCanvas.

	"fill in upper-left inside corner"
	self drawHLineFrom: left to: (left + 2) y: y + 2 color: color on: aCanvas.
	self drawHLineFrom: left to: (left + 1) y: y + 3 color: color on: aCanvas.
	self drawPoint: (left + 1)@(y + 3) color: shadowColor on: aCanvas.

	self drawHLineFrom: gapStart to: gapEnd y: y + 2 color: color on: aCanvas.
	self drawHLineFrom: gapStart + 1 to: gapEnd - 1 y: y + 3 color: color on: aCanvas.
	self drawHLineFrom: gapStart + 1 to: gapEnd - 1 y: y + 4 color: color on: aCanvas.
	self drawHLineFrom: gapStart + 2 to: gapEnd - 2 y: y + 5 color: color on: aCanvas.

	self drawHLineFrom: (left + 2) to: gapStart y: y + 2 color: shadowColor on: aCanvas.
	self drawHLineFrom: gapEnd to: right - 2 y: y + 2 color: shadowColor on: aCanvas.
	self drawHLineFrom: gapStart + 2 to: gapEnd - 2 y: y + 6 color: shadowColor on: aCanvas.

	self drawPoint: gapStart@(y + 3) color: shadowColor on: aCanvas.
	self drawPoint: gapStart@(y + 4) color: shadowColor on: aCanvas.
	self drawPoint: (gapStart + 1)@(y + 5) color: shadowColor on: aCanvas.

	self drawPoint: (gapEnd - 1)@(y + 3) color: shadowColor on: aCanvas.
	self drawPoint: (gapEnd - 1)@(y + 4) color: shadowColor on: aCanvas.
	self drawPoint: (gapEnd - 2)@(y + 5) color: shadowColor on: aCanvas.

	self drawPoint: (right - 1)@y color: shadowColor on: aCanvas.
	self drawPoint: (right - 2)@(y + 1) color: shadowColor on: aCanvas.

! !

!CommandScriptBlockMorph methodsFor: 'drawing' stamp: 'jens 3/16/2010 22:37'!
drawOn: aCanvas 

	| c |

	topBarBottom _ self top + self topBarHeight.
	self isForever
		ifTrue: [blockBottom _ self bottom - 3]
		ifFalse: [blockBottom _ self bottom - 7].
	self contrastColor.

	self computeHighlightColors.
	c _ FormCanvas extent: self extent depth: 32.
	c _ c copyOffset: self topLeft negated.
	self drawTopEdgeOn: c.
	self drawTopBarOn: c.
	self drawVerticalBarOn: c.
	self drawBottomBarOn: c.

	self drawFinalOn: aCanvas fromCanvas: c.

	self drawInlinePaletteOn: aCanvas
! !

!CommandScriptBlockMorph methodsFor: 'drawing' stamp: 'jens 10/29/2009 23:18'!
drawTopBarOn: aCanvas 

	| left right y gapStart gapEnd |


	aCanvas
		fillRectangle: (self left@(self top + 5) corner: (self right - 1)@topBarBottom)
		color: color.
	aCanvas
		fillRectangle: ((self right - 1)@(self top + 3) corner: self right @topBarBottom)
		color: shadowColor.

	left _ CBlockBracketThickness - 1.
	right _ self width - 1.
	y _ topBarBottom - self top.
	gapStart _ left + PuzzleInset + 1.
	gapEnd _ gapStart + PuzzleWidth.

	self drawHLineFrom: left to: (right - 1) y: y color: color on: aCanvas.
	self drawHLineFrom: left to: (right - 2) y: y + 1 color: color on: aCanvas.

	self drawHLineFrom: left to: (left + 2) y: y + 2 color: color on: aCanvas.
	self drawHLineFrom: left to: (left + 1) y: y + 3 color: color on: aCanvas.
	self drawPoint: (left + 1)@(y + 3) color: shadowColor on: aCanvas.

	self drawHLineFrom: gapStart to: gapEnd y: y + 2 color: color on: aCanvas.
	self drawHLineFrom: gapStart + 1 to: gapEnd - 1 y: y + 3 color: color on: aCanvas.
	self drawHLineFrom: gapStart + 1 to: gapEnd - 1 y: y + 4 color: color on: aCanvas.
	self drawHLineFrom: gapStart + 2 to: gapEnd - 2 y: y + 5 color: color on: aCanvas.

	self drawHLineFrom: (left + 2) to: gapStart y: y + 2 color: shadowColor on: aCanvas.
	self drawHLineFrom: gapEnd to: right - 2 y: y + 2 color: shadowColor on: aCanvas.
	self drawHLineFrom: gapStart + 2 to: gapEnd - 2 y: y + 6 color: shadowColor on: aCanvas.

	self drawPoint: gapStart@(y + 3) color: shadowColor on: aCanvas.
	self drawPoint: gapStart@(y + 4) color: shadowColor on: aCanvas.
	self drawPoint: (gapStart + 1)@(y + 5) color: shadowColor on: aCanvas.

	self drawPoint: (gapEnd - 1)@(y + 3) color: shadowColor on: aCanvas.
	self drawPoint: (gapEnd - 1)@(y + 4) color: shadowColor on: aCanvas.
	self drawPoint: (gapEnd - 2)@(y + 5) color: shadowColor on: aCanvas.

	self drawPoint: (right - 1)@y color: shadowColor on: aCanvas.
	self drawPoint: (right - 2)@(y + 1) color: shadowColor on: aCanvas.
! !

!CommandScriptBlockMorph methodsFor: 'drawing' stamp: 'jens 10/29/2009 23:18'!
drawTopEdgeOn: aCanvas

	| right |

	right _ self width - 1.
	self drawHLineFrom: 2 to: right-2 y: 0 color: highlightColor1 on: aCanvas.
	self drawHLineFrom: 1 to: right-1 y: 1 color: highlightColor2 on: aCanvas.
	self drawHLineFrom: 0 to: right y: 2 color: color on: aCanvas.
	self drawHLineFrom: 0 to: right y: 3 color: color on: aCanvas.
	self drawHLineFrom: 0 to: right y: 4 color: color on: aCanvas.

! !

!CommandScriptBlockMorph methodsFor: 'drawing' stamp: 'jens 10/29/2009 22:59'!
drawVerticalBarOn: aCanvas 

	| left top barRight |
	left _ self left.
	barRight _ (left + CBlockBracketThickness) - 1.
	top _ self top.
	
	aCanvas
		fillRectangle: (left@(top + 5) corner: barRight@blockBottom)
		color: color.
	aCanvas
		fillRectangle: (left@(top + 2) corner: (left + 2)@blockBottom)
		color: highlightColor2.

	aCanvas
		fillRectangle: (barRight@(topBarBottom + 4) corner: (barRight + 1)@blockBottom)
		color: shadowColor.
! !

!CommandScriptBlockMorph methodsFor: 'drawing' stamp: 'jens 5/11/2010 13:11'!
fixBlockLayout
	"Update the positions of my submorphs."

	self fixBlockLayoutNoWrap! !

!CommandScriptBlockMorph methodsFor: 'drawing' stamp: 'jens 5/11/2010 13:13'!
fixBlockLayoutNoWrap
	"Update the positions of my submorphs."

	| oldExtent newW newH |
	blockLayoutNeeded ifFalse: [^ self].
	super fixBlockLayoutNoWrap.

	"fix nestedBlock and nextBlock in case they've been removed from me"
	(nestedBlock notNil and: [nestedBlock owner ~~ self]) ifTrue: [nestedBlock _ nil].

	"color = owner color ifFalse: [self color: owner color]."

	oldExtent _ self extent.
	newW _ oldExtent x max: 60.
	"newW _ newW max: self blockWidth."

	newH _ self topBarHeight + CBlockBracketThickness.
	"self isForever ifFalse: [newH _ newH + 4]."

	nestedBlock
		ifNil: [newH _ newH + 14]
		ifNotNil: [
			stretchHeight _ 0.
			nestedBlock fixBlockLayout.
			newH _ newH + nestedBlock fullBounds height - 1.
			ScratchTranslator isRTL
				ifTrue: [nestedBlock position: self topRight - ((CBlockBracketThickness + nestedBlock width)@0)
					+ (0@(self topBarHeight + 3))]
				ifFalse: [nestedBlock position: self position + (CBlockBracketThickness@(self topBarHeight + 3))].
			nestedBlock blockSequence last isStopOrForever ifTrue: [newH _ newH + 4]].
	self extent: newW@newH + (0@stretchHeight).
	ScratchTranslator isRTL ifTrue: [
		self left: self left + (oldExtent x - newW)].

! !

!CommandScriptBlockMorph methodsFor: 'drawing' stamp: 'jens 12/17/2009 02:33'!
nestedBlock
	^nestedBlock! !


!CommandScriptBlockMorph methodsFor: 'as yet unclassified' stamp: 'jens 12/14/2009 04:25'!
acceptsTypeOf: aBlockMorph
	"Answer true if I can accept a dropped reporter of the given type. Answer false by default."

	((aBlockMorph isKindOf: CommandBlockMorph) and: [
		(aBlockMorph isKindOf: HatBlockMorph) not ])
			ifTrue: [^true].
	^super acceptsTypeOf: aBlockMorph! !

!CommandScriptBlockMorph methodsFor: 'as yet unclassified' stamp: 'jens 12/3/2009 01:09'!
addItem
	| quoted |
	quoted _ nestedBlock.
	super addItem.
	quoted ifNotNil: [
		self attachBlock: quoted ]! !

!CommandScriptBlockMorph methodsFor: 'as yet unclassified' stamp: 'jens 5/17/2010 00:39'!
adjustInternals
	"private"

	| newSelector sdict quoted newSpec |
	(#(procedure procedureWithArgs) includes: selector) ifFalse: [^ self ].

	argMorphs size > 0 
		ifTrue: [
			sdict _ Dictionary new
				at: #procedure put: #procedureWithArgs;
				yourself]
		ifFalse: [
			sdict _ Dictionary new
				at: #procedureWithArgs put: #procedure;
				yourself].

	receiver ifNil: [^ self ].
	newSelector _ sdict at: selector ifAbsent: [selector].
	newSelector = selector ifTrue: [^ self].
	selector _ newSelector.

	quoted _ nestedBlock.
	newSpec _ self receiver blockSpecForSelector: selector.
	newSpec _ newSpec asMacRoman localized.

	self commandSpec: newSpec.

	quoted ifNotNil: [
		self attachBlock: quoted ]! !

!CommandScriptBlockMorph methodsFor: 'as yet unclassified' stamp: 'jens 6/30/2010 19:49'!
asBlockTuple
	"Answer a tuple (Array) describing this block and its arguments."

	| blockTuple arg argList val eval |
	blockTuple _ Array new: argMorphs size + 9.
	blockTuple
		at: 1 put: #byob;
		at: 2 put: self rcvr;
		at: 3 put: selector;
		at: 4 put: parameters asArray;
		at: 5 put: variables asArray;
		at: 6 put: type;
		at: 7 put: declarations;
		at: 8 put: isAtomic.


	argList _ argMorphs.
	argList _ self organizeArgs: argList.
	1 to: argList size do: [:i |
		arg _ argList at: i.
		(arg isKindOf: ArgMorph)
			ifTrue: [(arg isKindOf: ExpressionArgMorph)
				ifTrue: [
					val _ arg getExpression.
					arg isNumberExpression
						ifTrue: [val = ' ' asUTF8
							ifTrue: [eval _ val]
							ifFalse: [eval _ val asNumberNoError]]
						ifFalse: [eval _ arg evaluate]]
				ifFalse: [eval _ arg evaluate].
				blockTuple at: i + 8 put: eval]
			ifFalse: [blockTuple at: i + 8 put: arg asBlockTuple]].

	nestedBlock
		ifNil: [blockTuple at: blockTuple size put: nil]
		ifNotNil: [blockTuple at: blockTuple size put: nestedBlock tupleSequence]. 
	^ blockTuple

! !

!CommandScriptBlockMorph methodsFor: 'as yet unclassified' stamp: 'jens 10/30/2009 00:46'!
attachBlock: aBlockMorph
	"Attach the given block to me. Assume the block has been positioned correctly."

	self addMorph: aBlockMorph.
	nestedBlock _ aBlockMorph.
! !

!CommandScriptBlockMorph methodsFor: 'as yet unclassified' stamp: 'jens 10/30/2009 00:49'!
attachBlockNested: aBlockMorph
	"Attach the given block to me. Assume the block has been positioned correctly."

	(stretchHeight = 0)
			ifTrue: [self position: (aBlockMorph left)@(aBlockMorph top - self height + 4)].
	self addMorph: aBlockMorph.
	nestedBlock _ aBlockMorph.
! !

!CommandScriptBlockMorph methodsFor: 'as yet unclassified' stamp: 'jens 10/29/2009 23:48'!
blockAttachPoints: aSet
	"Answer a collection of possible attachment points for me. Each entry is an Association mapping a point to the morph to which a dropping command block could be attached."

	| result |

	result _ #().

	nestedBlock
		ifNil: [ScratchTranslator isRTL
			ifTrue: [result _ result copyWith: ((self topRight + (-12@(self topBarHeight + 7))) -> self)]
			ifFalse: [result _ result copyWith: ((self topLeft + (12@(self topBarHeight + 7))) -> self)]]
		ifNotNil: [nestedBlock blockAttachPoints: aSet].

	aSet addAll: result.
! !

!CommandScriptBlockMorph methodsFor: 'as yet unclassified' stamp: 'jens 10/30/2009 11:47'!
blockWidth
	| maxWidth |
	maxWidth _ 0.
	self firstBlockList do: [:b |
		maxWidth _ maxWidth max: b blockWidth ].
	^self width max: self bracketThickness + maxWidth! !

!CommandScriptBlockMorph methodsFor: 'as yet unclassified' stamp: 'jens 7/1/2010 20:35'!
body
	nestedBlock ifNil: [^nil].
	^nestedBlock fullCopy! !

!CommandScriptBlockMorph methodsFor: 'as yet unclassified' stamp: 'jens 4/17/2010 00:29'!
bodyLeft
	^self left! !

!CommandScriptBlockMorph methodsFor: 'as yet unclassified' stamp: 'jens 4/17/2010 00:29'!
bodyRight
	^self fullBounds right! !

!CommandScriptBlockMorph methodsFor: 'as yet unclassified' stamp: 'jens 10/29/2009 22:50'!
bracketThickness

	^ CBlockBracketThickness
! !

!CommandScriptBlockMorph methodsFor: 'as yet unclassified' stamp: 'jens 10/18/2010 02:15'!
containsPoint: aPoint

	cachedForm ifNil: [self updateCachedForm].
	^ (cachedForm isTransparentAt: aPoint - self fullBounds origin) not 
		and: [self fullBounds containsPoint: aPoint]
! !

!CommandScriptBlockMorph methodsFor: 'as yet unclassified' stamp: 'jens 9/14/2010 22:22'!
deleteVariableTemplate: aVarBlockMorph

	| quoted |
	quoted _ nestedBlock.
	super deleteVariableTemplate: aVarBlockMorph.
	quoted ifNotNil: [
		self attachBlock: quoted ]! !

!CommandScriptBlockMorph methodsFor: 'as yet unclassified' stamp: 'jens 10/30/2009 10:51'!
firstBlockList
	"Answer an array containing the block sequence for my first (and only) nested block. (An if-then-else block would have a second block list.)"

	nestedBlock
		ifNil: [^ #()]
		ifNotNil: [^ nestedBlock blockSequence].


! !

!CommandScriptBlockMorph methodsFor: 'as yet unclassified' stamp: 'jens 11/19/2009 23:17'!
firstBlockList: aBlockMorph
	"Add the given block as my first nested block sequence. Delete the old nested blocks, if any."

	nestedBlock ifNotNil: [nestedBlock delete].
	nestedBlock _ aBlockMorph.
	aBlockMorph ifNotNil: [self addMorph: aBlockMorph].

! !

!CommandScriptBlockMorph methodsFor: 'as yet unclassified' stamp: 'jens 6/8/2010 00:10'!
helpScreenName
	"Answer the name of the help screen for this hat block, or nil if no help is available."

	^'commandLambda'! !

!CommandScriptBlockMorph methodsFor: 'as yet unclassified' stamp: 'jens 1/4/2010 22:43'!
initialize

	super initialize.
	type _ #none.
	stretchHeight _ 0.
! !

!CommandScriptBlockMorph methodsFor: 'as yet unclassified' stamp: 'jens 5/4/2010 00:22'!
isBooleanFunction

	| reporter |
	reporter _ self allMorphs detect: [:m|
		(m isKindOf: CommandBlockMorph) and: [
			m selector = #doAnswer ]] ifNone: [^false].
	^ (reporter argMorphs first isKindOf: ReporterBlockMorph) and: [
			reporter argMorphs first isBooleanReporter]
! !

!CommandScriptBlockMorph methodsFor: 'as yet unclassified' stamp: 'jens 5/4/2010 00:18'!
isFunction
	self allMorphsDo: [:m|
		((m isKindOf: CommandBlockMorph) and: [
			m selector = #doAnswer ]) ifTrue: [^ true]].
	^ false! !

!CommandScriptBlockMorph methodsFor: 'as yet unclassified' stamp: 'jens 10/29/2009 23:54'!
isKindOf: aClass
	aClass = CBlockMorph
		ifTrue: [^true ].
	^super isKindOf: aClass! !

!CommandScriptBlockMorph methodsFor: 'as yet unclassified' stamp: 'jens 10/29/2009 22:50'!
nestedBlockAt: aPoint

	^ nestedBlock
! !

!CommandScriptBlockMorph methodsFor: 'as yet unclassified' stamp: 'jens 11/20/2009 00:22'!
nextBlock

	^nil! !

!CommandScriptBlockMorph methodsFor: 'as yet unclassified' stamp: 'jens 10/29/2009 23:49'!
nonControlFlowSubmorphs
	"Answer a collection of submorphs minus any blocks that are part of the control flow. For example, command blocks omit their submorph that is the next block in the block sequence, C-blocks omit both their next block and the first block of their nested block list, etc."

	^ submorphs select: [:m | m ~~ nestedBlock ]
! !

!CommandScriptBlockMorph methodsFor: 'as yet unclassified' stamp: 'jens 12/18/2009 11:15'!
optimized
	^self fullCopy! !

!CommandScriptBlockMorph methodsFor: 'as yet unclassified' stamp: 'jens 3/15/2010 01:33'!
privateBody
	"no copy"
	nestedBlock ifNil: [^nil].
	^nestedBlock! !

!CommandScriptBlockMorph methodsFor: 'as yet unclassified' stamp: 'jens 12/3/2009 01:10'!
removeItem
	| quoted |
	quoted _ nestedBlock.
	super removeItem.
	quoted ifNotNil: [
		self attachBlock: quoted ]! !

!CommandScriptBlockMorph methodsFor: 'as yet unclassified' stamp: 'jens 10/29/2009 23:52'!
stretchHeight: aNumber

	(stretchHeight = aNumber) ifTrue: [^ self].
	stretchHeight _ aNumber.
	blockLayoutNeeded _ true.
	self fixBlockLayout.
! !

!CommandScriptBlockMorph methodsFor: 'as yet unclassified' stamp: 'jens 6/28/2010 20:25'!
tabFields

	| nst |

	nst _ self nestedBlock.
	nst ifNotNil: [
		^ nst tabFields ].

	^ OrderedCollection new
! !

!CommandScriptBlockMorph methodsFor: 'as yet unclassified' stamp: 'jens 1/8/2010 04:23'!
topBarHeight
	"Answer the height of the top bar."

	| nonBlockSubmorphs |
	nonBlockSubmorphs _ self submorphs select: [:m |
		(m isKindOf: BlockMorph) not or: [argMorphs includes: m]].
	^ nonBlockSubmorphs inject: CBlockBracketThickness into: [:h :m | h max: (m height + 4)].

! !
